# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20220101

module OCI
  module AiSpeech
    # Module containing models for requests made to, and responses received from,
    # OCI AiSpeech services
    module Models
    end
  end
end

# Require models
require 'oci/ai_speech/models/audio_format_details'
require 'oci/ai_speech/models/change_customization_compartment_details'
require 'oci/ai_speech/models/change_transcription_job_compartment_details'
require 'oci/ai_speech/models/create_customization_details'
require 'oci/ai_speech/models/create_realtime_session_token_details'
require 'oci/ai_speech/models/create_transcription_job_details'
require 'oci/ai_speech/models/customization'
require 'oci/ai_speech/models/customization_collection'
require 'oci/ai_speech/models/customization_dataset_details'
require 'oci/ai_speech/models/customization_inference'
require 'oci/ai_speech/models/customization_inference_entity'
require 'oci/ai_speech/models/customization_model_details'
require 'oci/ai_speech/models/customization_referenced_entities'
require 'oci/ai_speech/models/customization_summary'
require 'oci/ai_speech/models/diarization'
require 'oci/ai_speech/models/entity'
require 'oci/ai_speech/models/entity_list'
require 'oci/ai_speech/models/entity_list_dataset'
require 'oci/ai_speech/models/input_location'
require 'oci/ai_speech/models/location_details'
require 'oci/ai_speech/models/object_list_dataset'
require 'oci/ai_speech/models/object_list_file_input_location'
require 'oci/ai_speech/models/object_list_inline_input_location'
require 'oci/ai_speech/models/object_location'
require 'oci/ai_speech/models/object_storage_dataset'
require 'oci/ai_speech/models/output_location'
require 'oci/ai_speech/models/profanity_transcription_filter'
require 'oci/ai_speech/models/pronunciation'
require 'oci/ai_speech/models/realtime_message'
require 'oci/ai_speech/models/realtime_message_ack_audio'
require 'oci/ai_speech/models/realtime_message_ack_audio_details'
require 'oci/ai_speech/models/realtime_message_authentication'
require 'oci/ai_speech/models/realtime_message_authentication_credentials'
require 'oci/ai_speech/models/realtime_message_authentication_token'
require 'oci/ai_speech/models/realtime_message_connect'
require 'oci/ai_speech/models/realtime_message_error'
require 'oci/ai_speech/models/realtime_message_out'
require 'oci/ai_speech/models/realtime_message_result'
require 'oci/ai_speech/models/realtime_message_result_transcription'
require 'oci/ai_speech/models/realtime_message_result_transcription_token'
require 'oci/ai_speech/models/realtime_message_send_final_result'
require 'oci/ai_speech/models/realtime_model_details'
require 'oci/ai_speech/models/realtime_parameters'
require 'oci/ai_speech/models/realtime_session_token'
require 'oci/ai_speech/models/sort_order'
require 'oci/ai_speech/models/synthesize_speech_details'
require 'oci/ai_speech/models/transcription_filter'
require 'oci/ai_speech/models/transcription_job'
require 'oci/ai_speech/models/transcription_job_collection'
require 'oci/ai_speech/models/transcription_job_summary'
require 'oci/ai_speech/models/transcription_model_details'
require 'oci/ai_speech/models/transcription_normalization'
require 'oci/ai_speech/models/transcription_settings'
require 'oci/ai_speech/models/transcription_task'
require 'oci/ai_speech/models/transcription_task_collection'
require 'oci/ai_speech/models/transcription_task_summary'
require 'oci/ai_speech/models/tts_audio_config'
require 'oci/ai_speech/models/tts_base_audio_config'
require 'oci/ai_speech/models/tts_configuration'
require 'oci/ai_speech/models/tts_oracle_configuration'
require 'oci/ai_speech/models/tts_oracle_model_details'
require 'oci/ai_speech/models/tts_oracle_speech_settings'
require 'oci/ai_speech/models/tts_oracle_tts1_standard_model_details'
require 'oci/ai_speech/models/tts_oracle_tts2_natural_model_details'
require 'oci/ai_speech/models/update_customization_details'
require 'oci/ai_speech/models/update_transcription_job_details'
require 'oci/ai_speech/models/voice_collection'
require 'oci/ai_speech/models/voice_summary'

# Require generated clients
require 'oci/ai_speech/ai_service_speech_client'
require 'oci/ai_speech/ai_service_speech_client_composite_operations'

# Require service utilities
require 'oci/ai_speech/util'
