# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20190531
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Resource Principal Session Token Details.
  class Bds::Models::ResourcePrincipalConfigurationSummary
    # **[Required]** the ID of the ResourcePrincipalConfiguration.
    # @return [String]
    attr_accessor :id

    # **[Required]** the OCID of the bdsInstance which is the parent resource id.
    # @return [String]
    attr_accessor :bds_instance_id

    # **[Required]** a user-friendly name. only ascii alphanumeric characters with no spaces allowed. the name does not have to be unique, and it may be changed. avoid entering confidential information.
    # @return [String]
    attr_accessor :display_name

    # **[Required]** the state of the ResourcePrincipalConfiguration.
    # @return [String]
    attr_accessor :lifecycle_state

    # the time the resource principal session token was refreshed, shown as an rfc 3339 formatted datetime string.
    # @return [DateTime]
    attr_accessor :time_token_refreshed

    # the time the resource principal session token will expired, shown as an rfc 3339 formatted datetime string.
    # @return [DateTime]
    attr_accessor :time_token_expiry

    # **[Required]** the time the ResourcePrincipalConfiguration was created, shown as an rfc 3339 formatted datetime string.
    # @return [DateTime]
    attr_accessor :time_created

    # **[Required]** the time the ResourcePrincipalConfiguration was updated, shown as an rfc 3339 formatted datetime string.
    #
    # @return [DateTime]
    attr_accessor :time_updated

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'bds_instance_id': :'bdsInstanceId',
        'display_name': :'displayName',
        'lifecycle_state': :'lifecycleState',
        'time_token_refreshed': :'timeTokenRefreshed',
        'time_token_expiry': :'timeTokenExpiry',
        'time_created': :'timeCreated',
        'time_updated': :'timeUpdated'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'bds_instance_id': :'String',
        'display_name': :'String',
        'lifecycle_state': :'String',
        'time_token_refreshed': :'DateTime',
        'time_token_expiry': :'DateTime',
        'time_created': :'DateTime',
        'time_updated': :'DateTime'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {#id} property
    # @option attributes [String] :bds_instance_id The value to assign to the {#bds_instance_id} property
    # @option attributes [String] :display_name The value to assign to the {#display_name} property
    # @option attributes [String] :lifecycle_state The value to assign to the {#lifecycle_state} property
    # @option attributes [DateTime] :time_token_refreshed The value to assign to the {#time_token_refreshed} property
    # @option attributes [DateTime] :time_token_expiry The value to assign to the {#time_token_expiry} property
    # @option attributes [DateTime] :time_created The value to assign to the {#time_created} property
    # @option attributes [DateTime] :time_updated The value to assign to the {#time_updated} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.id = attributes[:'id'] if attributes[:'id']

      self.bds_instance_id = attributes[:'bdsInstanceId'] if attributes[:'bdsInstanceId']

      raise 'You cannot provide both :bdsInstanceId and :bds_instance_id' if attributes.key?(:'bdsInstanceId') && attributes.key?(:'bds_instance_id')

      self.bds_instance_id = attributes[:'bds_instance_id'] if attributes[:'bds_instance_id']

      self.display_name = attributes[:'displayName'] if attributes[:'displayName']

      raise 'You cannot provide both :displayName and :display_name' if attributes.key?(:'displayName') && attributes.key?(:'display_name')

      self.display_name = attributes[:'display_name'] if attributes[:'display_name']

      self.lifecycle_state = attributes[:'lifecycleState'] if attributes[:'lifecycleState']

      raise 'You cannot provide both :lifecycleState and :lifecycle_state' if attributes.key?(:'lifecycleState') && attributes.key?(:'lifecycle_state')

      self.lifecycle_state = attributes[:'lifecycle_state'] if attributes[:'lifecycle_state']

      self.time_token_refreshed = attributes[:'timeTokenRefreshed'] if attributes[:'timeTokenRefreshed']

      raise 'You cannot provide both :timeTokenRefreshed and :time_token_refreshed' if attributes.key?(:'timeTokenRefreshed') && attributes.key?(:'time_token_refreshed')

      self.time_token_refreshed = attributes[:'time_token_refreshed'] if attributes[:'time_token_refreshed']

      self.time_token_expiry = attributes[:'timeTokenExpiry'] if attributes[:'timeTokenExpiry']

      raise 'You cannot provide both :timeTokenExpiry and :time_token_expiry' if attributes.key?(:'timeTokenExpiry') && attributes.key?(:'time_token_expiry')

      self.time_token_expiry = attributes[:'time_token_expiry'] if attributes[:'time_token_expiry']

      self.time_created = attributes[:'timeCreated'] if attributes[:'timeCreated']

      raise 'You cannot provide both :timeCreated and :time_created' if attributes.key?(:'timeCreated') && attributes.key?(:'time_created')

      self.time_created = attributes[:'time_created'] if attributes[:'time_created']

      self.time_updated = attributes[:'timeUpdated'] if attributes[:'timeUpdated']

      raise 'You cannot provide both :timeUpdated and :time_updated' if attributes.key?(:'timeUpdated') && attributes.key?(:'time_updated')

      self.time_updated = attributes[:'time_updated'] if attributes[:'time_updated']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        bds_instance_id == other.bds_instance_id &&
        display_name == other.display_name &&
        lifecycle_state == other.lifecycle_state &&
        time_token_refreshed == other.time_token_refreshed &&
        time_token_expiry == other.time_token_expiry &&
        time_created == other.time_created &&
        time_updated == other.time_updated
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, bds_instance_id, display_name, lifecycle_state, time_token_refreshed, time_token_expiry, time_created, time_updated].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
