# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20181231
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # List of subcategories under a service.
  class Cims::Models::SubCategories
    # Subcategory list.
    # @return [Hash<String, String>]
    attr_accessor :service_category

    # Schema of a subcategory.
    # @return [String]
    attr_accessor :schema

    # Flag to identify if subComponent is present
    # @return [String]
    attr_accessor :has_sub_category

    # The sub component list for MOS Taxonomy.
    # @return [Array<OCI::Cims::Models::SubComponents>]
    attr_accessor :sub_categories

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'service_category': :'serviceCategory',
        'schema': :'schema',
        'has_sub_category': :'hasSubCategory',
        'sub_categories': :'subCategories'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'service_category': :'Hash<String, String>',
        'schema': :'String',
        'has_sub_category': :'String',
        'sub_categories': :'Array<OCI::Cims::Models::SubComponents>'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [Hash<String, String>] :service_category The value to assign to the {#service_category} property
    # @option attributes [String] :schema The value to assign to the {#schema} property
    # @option attributes [String] :has_sub_category The value to assign to the {#has_sub_category} property
    # @option attributes [Array<OCI::Cims::Models::SubComponents>] :sub_categories The value to assign to the {#sub_categories} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.service_category = attributes[:'serviceCategory'] if attributes[:'serviceCategory']

      raise 'You cannot provide both :serviceCategory and :service_category' if attributes.key?(:'serviceCategory') && attributes.key?(:'service_category')

      self.service_category = attributes[:'service_category'] if attributes[:'service_category']

      self.schema = attributes[:'schema'] if attributes[:'schema']

      self.has_sub_category = attributes[:'hasSubCategory'] if attributes[:'hasSubCategory']

      raise 'You cannot provide both :hasSubCategory and :has_sub_category' if attributes.key?(:'hasSubCategory') && attributes.key?(:'has_sub_category')

      self.has_sub_category = attributes[:'has_sub_category'] if attributes[:'has_sub_category']

      self.sub_categories = attributes[:'subCategories'] if attributes[:'subCategories']

      raise 'You cannot provide both :subCategories and :sub_categories' if attributes.key?(:'subCategories') && attributes.key?(:'sub_categories')

      self.sub_categories = attributes[:'sub_categories'] if attributes[:'sub_categories']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        service_category == other.service_category &&
        schema == other.schema &&
        has_sub_category == other.has_sub_category &&
        sub_categories == other.sub_categories
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [service_category, schema, has_sub_category, sub_categories].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
