# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20240102
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Summary of patch recommendations for databases.
  class Dblm::Models::PatchRecommendationsDetailsSummary
    # **[Required]** Name of the patch recommendation.
    # @return [String]
    attr_accessor :patch_name

    # **[Required]** Description of the patch recommendation.
    # @return [String]
    attr_accessor :abstract_text

    # **[Required]** Classification of the patch recommendation.
    # @return [String]
    attr_accessor :classification_name

    # **[Required]** Evaluation date for the patch recommendation.
    # @return [DateTime]
    attr_accessor :time_evaluated

    # **[Required]** If the patch has a fix for a CVE.
    # @return [BOOLEAN]
    attr_accessor :has_fix_for_cve

    # **[Required]** Release date for the patch.
    # @return [DateTime]
    attr_accessor :time_released

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'patch_name': :'patchName',
        'abstract_text': :'abstractText',
        'classification_name': :'classificationName',
        'time_evaluated': :'timeEvaluated',
        'has_fix_for_cve': :'hasFixForCve',
        'time_released': :'timeReleased'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'patch_name': :'String',
        'abstract_text': :'String',
        'classification_name': :'String',
        'time_evaluated': :'DateTime',
        'has_fix_for_cve': :'BOOLEAN',
        'time_released': :'DateTime'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :patch_name The value to assign to the {#patch_name} property
    # @option attributes [String] :abstract_text The value to assign to the {#abstract_text} property
    # @option attributes [String] :classification_name The value to assign to the {#classification_name} property
    # @option attributes [DateTime] :time_evaluated The value to assign to the {#time_evaluated} property
    # @option attributes [BOOLEAN] :has_fix_for_cve The value to assign to the {#has_fix_for_cve} property
    # @option attributes [DateTime] :time_released The value to assign to the {#time_released} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.patch_name = attributes[:'patchName'] if attributes[:'patchName']

      raise 'You cannot provide both :patchName and :patch_name' if attributes.key?(:'patchName') && attributes.key?(:'patch_name')

      self.patch_name = attributes[:'patch_name'] if attributes[:'patch_name']

      self.abstract_text = attributes[:'abstractText'] if attributes[:'abstractText']

      raise 'You cannot provide both :abstractText and :abstract_text' if attributes.key?(:'abstractText') && attributes.key?(:'abstract_text')

      self.abstract_text = attributes[:'abstract_text'] if attributes[:'abstract_text']

      self.classification_name = attributes[:'classificationName'] if attributes[:'classificationName']

      raise 'You cannot provide both :classificationName and :classification_name' if attributes.key?(:'classificationName') && attributes.key?(:'classification_name')

      self.classification_name = attributes[:'classification_name'] if attributes[:'classification_name']

      self.time_evaluated = attributes[:'timeEvaluated'] if attributes[:'timeEvaluated']

      raise 'You cannot provide both :timeEvaluated and :time_evaluated' if attributes.key?(:'timeEvaluated') && attributes.key?(:'time_evaluated')

      self.time_evaluated = attributes[:'time_evaluated'] if attributes[:'time_evaluated']

      self.has_fix_for_cve = attributes[:'hasFixForCve'] unless attributes[:'hasFixForCve'].nil?

      raise 'You cannot provide both :hasFixForCve and :has_fix_for_cve' if attributes.key?(:'hasFixForCve') && attributes.key?(:'has_fix_for_cve')

      self.has_fix_for_cve = attributes[:'has_fix_for_cve'] unless attributes[:'has_fix_for_cve'].nil?

      self.time_released = attributes[:'timeReleased'] if attributes[:'timeReleased']

      raise 'You cannot provide both :timeReleased and :time_released' if attributes.key?(:'timeReleased') && attributes.key?(:'time_released')

      self.time_released = attributes[:'time_released'] if attributes[:'time_released']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        patch_name == other.patch_name &&
        abstract_text == other.abstract_text &&
        classification_name == other.classification_name &&
        time_evaluated == other.time_evaluated &&
        has_fix_for_cve == other.has_fix_for_cve &&
        time_released == other.time_released
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [patch_name, abstract_text, classification_name, time_evaluated, has_fix_for_cve, time_released].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
