# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20250228
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # Details of the Policy associated
  class FleetAppsManagement::Models::ComplianceDetailPolicy
    # **[Required]** Compliance Policy Id
    # @return [String]
    attr_accessor :compliance_policy_id

    # Compliane Policy DisplayName
    # @return [String]
    attr_accessor :compliance_policy_display_name

    # Compliane Policy Rule Id
    # @return [String]
    attr_accessor :compliance_policy_rule_id

    # Product Name
    # @return [String]
    attr_accessor :compliance_policy_rule_display_name

    # Grace period in days,weeks,months or years the exemption is applicable for the rule.
    # @return [String]
    attr_accessor :grace_period

    # @return [OCI::FleetAppsManagement::Models::PatchSelectionDetails]
    attr_accessor :patch_selection

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'compliance_policy_id': :'compliancePolicyId',
        'compliance_policy_display_name': :'compliancePolicyDisplayName',
        'compliance_policy_rule_id': :'compliancePolicyRuleId',
        'compliance_policy_rule_display_name': :'compliancePolicyRuleDisplayName',
        'grace_period': :'gracePeriod',
        'patch_selection': :'patchSelection'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'compliance_policy_id': :'String',
        'compliance_policy_display_name': :'String',
        'compliance_policy_rule_id': :'String',
        'compliance_policy_rule_display_name': :'String',
        'grace_period': :'String',
        'patch_selection': :'OCI::FleetAppsManagement::Models::PatchSelectionDetails'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :compliance_policy_id The value to assign to the {#compliance_policy_id} property
    # @option attributes [String] :compliance_policy_display_name The value to assign to the {#compliance_policy_display_name} property
    # @option attributes [String] :compliance_policy_rule_id The value to assign to the {#compliance_policy_rule_id} property
    # @option attributes [String] :compliance_policy_rule_display_name The value to assign to the {#compliance_policy_rule_display_name} property
    # @option attributes [String] :grace_period The value to assign to the {#grace_period} property
    # @option attributes [OCI::FleetAppsManagement::Models::PatchSelectionDetails] :patch_selection The value to assign to the {#patch_selection} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.compliance_policy_id = attributes[:'compliancePolicyId'] if attributes[:'compliancePolicyId']

      raise 'You cannot provide both :compliancePolicyId and :compliance_policy_id' if attributes.key?(:'compliancePolicyId') && attributes.key?(:'compliance_policy_id')

      self.compliance_policy_id = attributes[:'compliance_policy_id'] if attributes[:'compliance_policy_id']

      self.compliance_policy_display_name = attributes[:'compliancePolicyDisplayName'] if attributes[:'compliancePolicyDisplayName']

      raise 'You cannot provide both :compliancePolicyDisplayName and :compliance_policy_display_name' if attributes.key?(:'compliancePolicyDisplayName') && attributes.key?(:'compliance_policy_display_name')

      self.compliance_policy_display_name = attributes[:'compliance_policy_display_name'] if attributes[:'compliance_policy_display_name']

      self.compliance_policy_rule_id = attributes[:'compliancePolicyRuleId'] if attributes[:'compliancePolicyRuleId']

      raise 'You cannot provide both :compliancePolicyRuleId and :compliance_policy_rule_id' if attributes.key?(:'compliancePolicyRuleId') && attributes.key?(:'compliance_policy_rule_id')

      self.compliance_policy_rule_id = attributes[:'compliance_policy_rule_id'] if attributes[:'compliance_policy_rule_id']

      self.compliance_policy_rule_display_name = attributes[:'compliancePolicyRuleDisplayName'] if attributes[:'compliancePolicyRuleDisplayName']

      raise 'You cannot provide both :compliancePolicyRuleDisplayName and :compliance_policy_rule_display_name' if attributes.key?(:'compliancePolicyRuleDisplayName') && attributes.key?(:'compliance_policy_rule_display_name')

      self.compliance_policy_rule_display_name = attributes[:'compliance_policy_rule_display_name'] if attributes[:'compliance_policy_rule_display_name']

      self.grace_period = attributes[:'gracePeriod'] if attributes[:'gracePeriod']

      raise 'You cannot provide both :gracePeriod and :grace_period' if attributes.key?(:'gracePeriod') && attributes.key?(:'grace_period')

      self.grace_period = attributes[:'grace_period'] if attributes[:'grace_period']

      self.patch_selection = attributes[:'patchSelection'] if attributes[:'patchSelection']

      raise 'You cannot provide both :patchSelection and :patch_selection' if attributes.key?(:'patchSelection') && attributes.key?(:'patch_selection')

      self.patch_selection = attributes[:'patch_selection'] if attributes[:'patch_selection']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        compliance_policy_id == other.compliance_policy_id &&
        compliance_policy_display_name == other.compliance_policy_display_name &&
        compliance_policy_rule_id == other.compliance_policy_rule_id &&
        compliance_policy_rule_display_name == other.compliance_policy_rule_display_name &&
        grace_period == other.grace_period &&
        patch_selection == other.patch_selection
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [compliance_policy_id, compliance_policy_display_name, compliance_policy_rule_id, compliance_policy_rule_display_name, grace_period, patch_selection].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
