# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20250228
require 'date'
require 'logger'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The properties of the component.
  class FleetAppsManagement::Models::ComponentProperties
    ACTION_ON_FAILURE_ENUM = [
      ACTION_ON_FAILURE_ABORT = 'ABORT'.freeze,
      ACTION_ON_FAILURE_CONTINUE = 'CONTINUE'.freeze,
      ACTION_ON_FAILURE_ROLLBACK = 'ROLLBACK'.freeze,
      ACTION_ON_FAILURE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    # @return [OCI::FleetAppsManagement::Models::RunOnDetails]
    attr_accessor :run_on

    # Build control flow conditions that determine the relevance of the task execution.
    #
    # @return [String]
    attr_accessor :pre_condition

    # **[Required]** The action to be taken in case of a failure.
    # @return [String]
    attr_reader :action_on_failure

    # @return [OCI::FleetAppsManagement::Models::PauseDetails]
    attr_accessor :pause_details

    # @return [OCI::FleetAppsManagement::Models::TaskNotificationPreferences]
    attr_accessor :notification_preferences

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'run_on': :'runOn',
        'pre_condition': :'preCondition',
        'action_on_failure': :'actionOnFailure',
        'pause_details': :'pauseDetails',
        'notification_preferences': :'notificationPreferences'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'run_on': :'OCI::FleetAppsManagement::Models::RunOnDetails',
        'pre_condition': :'String',
        'action_on_failure': :'String',
        'pause_details': :'OCI::FleetAppsManagement::Models::PauseDetails',
        'notification_preferences': :'OCI::FleetAppsManagement::Models::TaskNotificationPreferences'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [OCI::FleetAppsManagement::Models::RunOnDetails] :run_on The value to assign to the {#run_on} property
    # @option attributes [String] :pre_condition The value to assign to the {#pre_condition} property
    # @option attributes [String] :action_on_failure The value to assign to the {#action_on_failure} property
    # @option attributes [OCI::FleetAppsManagement::Models::PauseDetails] :pause_details The value to assign to the {#pause_details} property
    # @option attributes [OCI::FleetAppsManagement::Models::TaskNotificationPreferences] :notification_preferences The value to assign to the {#notification_preferences} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.run_on = attributes[:'runOn'] if attributes[:'runOn']

      raise 'You cannot provide both :runOn and :run_on' if attributes.key?(:'runOn') && attributes.key?(:'run_on')

      self.run_on = attributes[:'run_on'] if attributes[:'run_on']

      self.pre_condition = attributes[:'preCondition'] if attributes[:'preCondition']

      raise 'You cannot provide both :preCondition and :pre_condition' if attributes.key?(:'preCondition') && attributes.key?(:'pre_condition')

      self.pre_condition = attributes[:'pre_condition'] if attributes[:'pre_condition']

      self.action_on_failure = attributes[:'actionOnFailure'] if attributes[:'actionOnFailure']

      raise 'You cannot provide both :actionOnFailure and :action_on_failure' if attributes.key?(:'actionOnFailure') && attributes.key?(:'action_on_failure')

      self.action_on_failure = attributes[:'action_on_failure'] if attributes[:'action_on_failure']

      self.pause_details = attributes[:'pauseDetails'] if attributes[:'pauseDetails']

      raise 'You cannot provide both :pauseDetails and :pause_details' if attributes.key?(:'pauseDetails') && attributes.key?(:'pause_details')

      self.pause_details = attributes[:'pause_details'] if attributes[:'pause_details']

      self.notification_preferences = attributes[:'notificationPreferences'] if attributes[:'notificationPreferences']

      raise 'You cannot provide both :notificationPreferences and :notification_preferences' if attributes.key?(:'notificationPreferences') && attributes.key?(:'notification_preferences')

      self.notification_preferences = attributes[:'notification_preferences'] if attributes[:'notification_preferences']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] action_on_failure Object to be assigned
    def action_on_failure=(action_on_failure)
      # rubocop:disable Style/ConditionalAssignment
      if action_on_failure && !ACTION_ON_FAILURE_ENUM.include?(action_on_failure)
        OCI.logger.debug("Unknown value for 'action_on_failure' [" + action_on_failure + "]. Mapping to 'ACTION_ON_FAILURE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @action_on_failure = ACTION_ON_FAILURE_UNKNOWN_ENUM_VALUE
      else
        @action_on_failure = action_on_failure
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        run_on == other.run_on &&
        pre_condition == other.pre_condition &&
        action_on_failure == other.action_on_failure &&
        pause_details == other.pause_details &&
        notification_preferences == other.notification_preferences
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [run_on, pre_condition, action_on_failure, pause_details, notification_preferences].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
