# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20231130

module OCI
  module GenerativeAiInference
    # Module containing models for requests made to, and responses received from,
    # OCI GenerativeAiInference services
    module Models
    end
  end
end

# Require models
require 'oci/generative_ai_inference/models/apply_guardrails_details'
require 'oci/generative_ai_inference/models/apply_guardrails_result'
require 'oci/generative_ai_inference/models/assistant_message'
require 'oci/generative_ai_inference/models/base_chat_request'
require 'oci/generative_ai_inference/models/base_chat_response'
require 'oci/generative_ai_inference/models/category_score'
require 'oci/generative_ai_inference/models/chat_choice'
require 'oci/generative_ai_inference/models/chat_content'
require 'oci/generative_ai_inference/models/chat_details'
require 'oci/generative_ai_inference/models/chat_result'
require 'oci/generative_ai_inference/models/choice'
require 'oci/generative_ai_inference/models/citation'
require 'oci/generative_ai_inference/models/cohere_chat_bot_message'
require 'oci/generative_ai_inference/models/cohere_chat_request'
require 'oci/generative_ai_inference/models/cohere_chat_response'
require 'oci/generative_ai_inference/models/cohere_llm_inference_request'
require 'oci/generative_ai_inference/models/cohere_llm_inference_response'
require 'oci/generative_ai_inference/models/cohere_message'
require 'oci/generative_ai_inference/models/cohere_parameter_definition'
require 'oci/generative_ai_inference/models/cohere_response_format'
require 'oci/generative_ai_inference/models/cohere_response_json_format'
require 'oci/generative_ai_inference/models/cohere_response_text_format'
require 'oci/generative_ai_inference/models/cohere_system_message'
require 'oci/generative_ai_inference/models/cohere_tool'
require 'oci/generative_ai_inference/models/cohere_tool_call'
require 'oci/generative_ai_inference/models/cohere_tool_message'
require 'oci/generative_ai_inference/models/cohere_tool_result'
require 'oci/generative_ai_inference/models/cohere_user_message'
require 'oci/generative_ai_inference/models/completion_tokens_details'
require 'oci/generative_ai_inference/models/content_moderation_configuration'
require 'oci/generative_ai_inference/models/content_moderation_result'
require 'oci/generative_ai_inference/models/dedicated_serving_mode'
require 'oci/generative_ai_inference/models/document'
require 'oci/generative_ai_inference/models/document_rank'
require 'oci/generative_ai_inference/models/embed_text_details'
require 'oci/generative_ai_inference/models/embed_text_result'
require 'oci/generative_ai_inference/models/function_call'
require 'oci/generative_ai_inference/models/function_definition'
require 'oci/generative_ai_inference/models/generate_text_details'
require 'oci/generative_ai_inference/models/generate_text_result'
require 'oci/generative_ai_inference/models/generated_text'
require 'oci/generative_ai_inference/models/generic_chat_request'
require 'oci/generative_ai_inference/models/generic_chat_response'
require 'oci/generative_ai_inference/models/guardrail_configs'
require 'oci/generative_ai_inference/models/guardrails_input'
require 'oci/generative_ai_inference/models/guardrails_results'
require 'oci/generative_ai_inference/models/guardrails_text_input'
require 'oci/generative_ai_inference/models/image_content'
require 'oci/generative_ai_inference/models/image_url'
require 'oci/generative_ai_inference/models/llama_llm_inference_request'
require 'oci/generative_ai_inference/models/llama_llm_inference_response'
require 'oci/generative_ai_inference/models/llm_inference_request'
require 'oci/generative_ai_inference/models/llm_inference_response'
require 'oci/generative_ai_inference/models/logprobs'
require 'oci/generative_ai_inference/models/message'
require 'oci/generative_ai_inference/models/on_demand_serving_mode'
require 'oci/generative_ai_inference/models/personally_identifiable_information_configuration'
require 'oci/generative_ai_inference/models/personally_identifiable_information_result'
require 'oci/generative_ai_inference/models/prompt_injection_configuration'
require 'oci/generative_ai_inference/models/prompt_injection_protection_result'
require 'oci/generative_ai_inference/models/prompt_tokens_details'
require 'oci/generative_ai_inference/models/rerank_text_details'
require 'oci/generative_ai_inference/models/rerank_text_result'
require 'oci/generative_ai_inference/models/search_query'
require 'oci/generative_ai_inference/models/serving_mode'
require 'oci/generative_ai_inference/models/stream_options'
require 'oci/generative_ai_inference/models/summarize_text_details'
require 'oci/generative_ai_inference/models/summarize_text_result'
require 'oci/generative_ai_inference/models/system_message'
require 'oci/generative_ai_inference/models/text_content'
require 'oci/generative_ai_inference/models/token_likelihood'
require 'oci/generative_ai_inference/models/tool_call'
require 'oci/generative_ai_inference/models/tool_choice'
require 'oci/generative_ai_inference/models/tool_choice_auto'
require 'oci/generative_ai_inference/models/tool_choice_function'
require 'oci/generative_ai_inference/models/tool_choice_none'
require 'oci/generative_ai_inference/models/tool_choice_required'
require 'oci/generative_ai_inference/models/tool_definition'
require 'oci/generative_ai_inference/models/tool_message'
require 'oci/generative_ai_inference/models/usage'
require 'oci/generative_ai_inference/models/user_message'

# Require generated clients
require 'oci/generative_ai_inference/generative_ai_inference_client'

# Require service utilities
require 'oci/generative_ai_inference/util'
