# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20200407
require 'date'
require 'logger'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # A container for your OCI GoldenGate resources, such as the OCI GoldenGate deployment console.
  #
  class GoldenGate::Models::Deployment
    DEPLOYMENT_ROLE_ENUM = [
      DEPLOYMENT_ROLE_PRIMARY = 'PRIMARY'.freeze,
      DEPLOYMENT_ROLE_STANDBY = 'STANDBY'.freeze,
      DEPLOYMENT_ROLE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    LIFECYCLE_STATE_ENUM = [
      LIFECYCLE_STATE_CREATING = 'CREATING'.freeze,
      LIFECYCLE_STATE_UPDATING = 'UPDATING'.freeze,
      LIFECYCLE_STATE_ACTIVE = 'ACTIVE'.freeze,
      LIFECYCLE_STATE_INACTIVE = 'INACTIVE'.freeze,
      LIFECYCLE_STATE_DELETING = 'DELETING'.freeze,
      LIFECYCLE_STATE_DELETED = 'DELETED'.freeze,
      LIFECYCLE_STATE_FAILED = 'FAILED'.freeze,
      LIFECYCLE_STATE_NEEDS_ATTENTION = 'NEEDS_ATTENTION'.freeze,
      LIFECYCLE_STATE_IN_PROGRESS = 'IN_PROGRESS'.freeze,
      LIFECYCLE_STATE_CANCELING = 'CANCELING'.freeze,
      LIFECYCLE_STATE_CANCELED = 'CANCELED'.freeze,
      LIFECYCLE_STATE_SUCCEEDED = 'SUCCEEDED'.freeze,
      LIFECYCLE_STATE_WAITING = 'WAITING'.freeze,
      LIFECYCLE_STATE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    LIFECYCLE_SUB_STATE_ENUM = [
      LIFECYCLE_SUB_STATE_RECOVERING = 'RECOVERING'.freeze,
      LIFECYCLE_SUB_STATE_STARTING = 'STARTING'.freeze,
      LIFECYCLE_SUB_STATE_STOPPING = 'STOPPING'.freeze,
      LIFECYCLE_SUB_STATE_MOVING = 'MOVING'.freeze,
      LIFECYCLE_SUB_STATE_UPGRADING = 'UPGRADING'.freeze,
      LIFECYCLE_SUB_STATE_RESTORING = 'RESTORING'.freeze,
      LIFECYCLE_SUB_STATE_BACKUP_IN_PROGRESS = 'BACKUP_IN_PROGRESS'.freeze,
      LIFECYCLE_SUB_STATE_ROLLBACK_IN_PROGRESS = 'ROLLBACK_IN_PROGRESS'.freeze,
      LIFECYCLE_SUB_STATE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    LICENSE_MODEL_ENUM = [
      LICENSE_MODEL_LICENSE_INCLUDED = 'LICENSE_INCLUDED'.freeze,
      LICENSE_MODEL_BRING_YOUR_OWN_LICENSE = 'BRING_YOUR_OWN_LICENSE'.freeze,
      LICENSE_MODEL_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    ENVIRONMENT_TYPE_ENUM = [
      ENVIRONMENT_TYPE_PRODUCTION = 'PRODUCTION'.freeze,
      ENVIRONMENT_TYPE_DEVELOPMENT_OR_TESTING = 'DEVELOPMENT_OR_TESTING'.freeze,
      ENVIRONMENT_TYPE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    CATEGORY_ENUM = [
      CATEGORY_DATA_REPLICATION = 'DATA_REPLICATION'.freeze,
      CATEGORY_STREAM_ANALYTICS = 'STREAM_ANALYTICS'.freeze,
      CATEGORY_DATA_TRANSFORMS = 'DATA_TRANSFORMS'.freeze,
      CATEGORY_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    DEPLOYMENT_TYPE_ENUM = [
      DEPLOYMENT_TYPE_OGG = 'OGG'.freeze,
      DEPLOYMENT_TYPE_DATABASE_ORACLE = 'DATABASE_ORACLE'.freeze,
      DEPLOYMENT_TYPE_BIGDATA = 'BIGDATA'.freeze,
      DEPLOYMENT_TYPE_DATABASE_MICROSOFT_SQLSERVER = 'DATABASE_MICROSOFT_SQLSERVER'.freeze,
      DEPLOYMENT_TYPE_DATABASE_MYSQL = 'DATABASE_MYSQL'.freeze,
      DEPLOYMENT_TYPE_DATABASE_POSTGRESQL = 'DATABASE_POSTGRESQL'.freeze,
      DEPLOYMENT_TYPE_DATABASE_DB2_ZOS = 'DATABASE_DB2ZOS'.freeze,
      DEPLOYMENT_TYPE_GGSA = 'GGSA'.freeze,
      DEPLOYMENT_TYPE_DATA_TRANSFORMS = 'DATA_TRANSFORMS'.freeze,
      DEPLOYMENT_TYPE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    NEXT_MAINTENANCE_ACTION_TYPE_ENUM = [
      NEXT_MAINTENANCE_ACTION_TYPE_UPGRADE = 'UPGRADE'.freeze,
      NEXT_MAINTENANCE_ACTION_TYPE_UNKNOWN_ENUM_VALUE = 'UNKNOWN_ENUM_VALUE'.freeze
    ].freeze

    # **[Required]** The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the deployment being referenced.
    #
    # @return [String]
    attr_accessor :id

    # An object's Display Name.
    #
    # @return [String]
    attr_accessor :display_name

    # Metadata about this specific object.
    #
    # @return [String]
    attr_accessor :description

    # **[Required]** The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment being referenced.
    #
    # @return [String]
    attr_accessor :compartment_id

    # The availability domain of a placement.
    # @return [String]
    attr_accessor :availability_domain

    # The fault domain of a placement.
    # @return [String]
    attr_accessor :fault_domain

    # The type of the deployment role.
    #
    # @return [String]
    attr_reader :deployment_role

    # The time of the last role change. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_role_changed

    # The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the deployment being referenced.
    #
    # @return [String]
    attr_accessor :source_deployment_id

    # An array of local peers of deployment
    #
    # @return [Array<OCI::GoldenGate::Models::DeploymentPlacementInfo>]
    attr_accessor :placements

    # The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the backup being referenced.
    #
    # @return [String]
    attr_accessor :deployment_backup_id

    # The time the resource was created. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_created

    # The time the resource was last updated. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_updated

    # Possible lifecycle states.
    #
    # @return [String]
    attr_reader :lifecycle_state

    # Possible GGS lifecycle sub-states.
    #
    # @return [String]
    attr_reader :lifecycle_sub_state

    # Describes the object's current state in detail. For example, it can be used to provide
    # actionable information for a resource in a Failed state.
    #
    # @return [String]
    attr_accessor :lifecycle_details

    # A simple key-value pair that is applied without any predefined name, type, or scope. Exists
    # for cross-compatibility only.
    #
    # Example: `{\"bar-key\": \"value\"}`
    #
    # @return [Hash<String, String>]
    attr_accessor :freeform_tags

    # Tags defined for this resource. Each key is predefined and scoped to a namespace.
    #
    # Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
    #
    # @return [Hash<String, Hash<String, Object>>]
    attr_accessor :defined_tags

    # Locks associated with this resource.
    # @return [Array<OCI::GoldenGate::Models::ResourceLock>]
    attr_accessor :locks

    # True if all of the aggregate resources are working correctly.
    #
    # @return [BOOLEAN]
    attr_accessor :is_healthy

    # **[Required]** The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the subnet of the deployment's private endpoint.
    # The subnet must be a private subnet. For backward compatibility, public subnets are allowed until May 31 2025,
    # after which the private subnet will be enforced.
    #
    # @return [String]
    attr_accessor :subnet_id

    # The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of a public subnet in the customer tenancy.
    # Can be provided only for public deployments. If provided, the loadbalancer will be created in this subnet instead of the service tenancy.
    # For backward compatibility, this is an optional property. It will become mandatory for public deployments after October 1, 2024.
    #
    # @return [String]
    attr_accessor :load_balancer_subnet_id

    # The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the loadbalancer in the customer's subnet.
    # The loadbalancer of the public deployment created in the customer subnet.
    #
    # @return [String]
    attr_accessor :load_balancer_id

    # A three-label Fully Qualified Domain Name (FQDN) for a resource.
    #
    # @return [String]
    attr_accessor :fqdn

    # **[Required]** The Oracle license model that applies to a Deployment.
    #
    # @return [String]
    attr_reader :license_model

    # Specifies whether the deployment is used in a production or development/testing environment.
    #
    # @return [String]
    attr_reader :environment_type

    # **[Required]** The deployment category defines the broad separation of the deployment type into three categories.
    # Currently the separation is 'DATA_REPLICATION', 'STREAM_ANALYTICS' and 'DATA_TRANSFORMS'.
    #
    # @return [String]
    attr_reader :category

    # **[Required]** The Minimum number of OCPUs to be made available for this Deployment.
    #
    # @return [Integer]
    attr_accessor :cpu_core_count

    # **[Required]** Indicates if auto scaling is enabled for the Deployment's CPU core count.
    #
    # @return [BOOLEAN]
    attr_accessor :is_auto_scaling_enabled

    # An array of Network Security Group OCIDs used to define network access for either Deployments or Connections.
    #
    # @return [Array<String>]
    attr_accessor :nsg_ids

    # True if this object is publicly available.
    #
    # @return [BOOLEAN]
    attr_accessor :is_public

    # The public IP address representing the access point for the Deployment.
    #
    # @return [String]
    attr_accessor :public_ip_address

    # The private IP address in the customer's VCN representing the access point for the
    # associated endpoint service in the GoldenGate service VCN.
    #
    # @return [String]
    attr_accessor :private_ip_address

    # The URL of a resource.
    #
    # @return [String]
    attr_accessor :deployment_url

    # The system tags associated with this resource, if any. The system tags are set by Oracle
    # Cloud Infrastructure services. Each key is predefined and scoped to namespaces.  For more
    # information, see [Resource Tags](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/resourcetags.htm).
    #
    # Example: `{orcl-cloud: {free-tier-retain: true}}`
    #
    # @return [Hash<String, Hash<String, Object>>]
    attr_accessor :system_tags

    # Indicates if the resource is the the latest available version.
    #
    # @return [BOOLEAN]
    attr_accessor :is_latest_version

    # Note: Deprecated: Use timeOfNextMaintenance instead, or related upgrade records
    # to check, when deployment will be forced to upgrade to a newer version.
    # Old description:
    # The date the existing version in use will no longer be considered as usable
    # and an upgrade will be required.  This date is typically 6 months after the
    # version was released for use by GGS.  The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_upgrade_required

    # The amount of storage being utilized (in bytes)
    #
    # @return [Integer]
    attr_accessor :storage_utilization_in_bytes

    # Deprecated: This field is not updated and will be removed in future versions. If storage utilization exceeds the limit, the respective warning message will appear in deployment messages, which can be accessed through /messages?deploymentId=.
    # Indicator will be true if the amount of storage being utilized exceeds the allowable storage utilization limit.  Exceeding the limit may be an indication of a misconfiguration of the deployment's GoldenGate service.
    #
    # @return [BOOLEAN]
    attr_accessor :is_storage_utilization_limit_exceeded

    # **[Required]** The type of deployment, which can be any one of the Allowed values.
    # NOTE: Use of the value 'OGG' is maintained for backward compatibility purposes.
    #     Its use is discouraged in favor of 'DATABASE_ORACLE'.
    #
    # @return [String]
    attr_reader :deployment_type

    # @return [OCI::GoldenGate::Models::OggDeployment]
    attr_accessor :ogg_data

    # @return [OCI::GoldenGate::Models::DeploymentDiagnosticData]
    attr_accessor :deployment_diagnostic_data

    # @return [OCI::GoldenGate::Models::MaintenanceWindow]
    attr_accessor :maintenance_window

    # The time of next maintenance schedule. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_of_next_maintenance

    # Type of the next maintenance.
    #
    # @return [String]
    attr_reader :next_maintenance_action_type

    # Description of the next maintenance.
    #
    # @return [String]
    attr_accessor :next_maintenance_description

    # @return [OCI::GoldenGate::Models::MaintenanceConfiguration]
    attr_accessor :maintenance_configuration

    # The time until OGG version is supported. After this date has passed OGG version will not be available anymore. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2016-08-25T21:10:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_ogg_version_supported_until

    # @return [OCI::GoldenGate::Models::BackupSchedule]
    attr_accessor :backup_schedule

    # The timestamp of last deployment backup scheduled. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2024-10-25T18:19:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_last_backup_scheduled

    # The timestamp of next deployment backup scheduled. The format is defined by
    # [RFC3339](https://tools.ietf.org/html/rfc3339), such as `2024-10-26T20:19:29.600Z`.
    #
    # @return [DateTime]
    attr_accessor :time_next_backup_scheduled

    # List of ingress IP addresses from where the GoldenGate deployment connects to this connection's privateIp.
    # Customers may optionally set up ingress security rules to restrict traffic from these IP addresses.
    #
    # @return [Array<OCI::GoldenGate::Models::IngressIpDetails>]
    attr_accessor :ingress_ips

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'id',
        'display_name': :'displayName',
        'description': :'description',
        'compartment_id': :'compartmentId',
        'availability_domain': :'availabilityDomain',
        'fault_domain': :'faultDomain',
        'deployment_role': :'deploymentRole',
        'time_role_changed': :'timeRoleChanged',
        'source_deployment_id': :'sourceDeploymentId',
        'placements': :'placements',
        'deployment_backup_id': :'deploymentBackupId',
        'time_created': :'timeCreated',
        'time_updated': :'timeUpdated',
        'lifecycle_state': :'lifecycleState',
        'lifecycle_sub_state': :'lifecycleSubState',
        'lifecycle_details': :'lifecycleDetails',
        'freeform_tags': :'freeformTags',
        'defined_tags': :'definedTags',
        'locks': :'locks',
        'is_healthy': :'isHealthy',
        'subnet_id': :'subnetId',
        'load_balancer_subnet_id': :'loadBalancerSubnetId',
        'load_balancer_id': :'loadBalancerId',
        'fqdn': :'fqdn',
        'license_model': :'licenseModel',
        'environment_type': :'environmentType',
        'category': :'category',
        'cpu_core_count': :'cpuCoreCount',
        'is_auto_scaling_enabled': :'isAutoScalingEnabled',
        'nsg_ids': :'nsgIds',
        'is_public': :'isPublic',
        'public_ip_address': :'publicIpAddress',
        'private_ip_address': :'privateIpAddress',
        'deployment_url': :'deploymentUrl',
        'system_tags': :'systemTags',
        'is_latest_version': :'isLatestVersion',
        'time_upgrade_required': :'timeUpgradeRequired',
        'storage_utilization_in_bytes': :'storageUtilizationInBytes',
        'is_storage_utilization_limit_exceeded': :'isStorageUtilizationLimitExceeded',
        'deployment_type': :'deploymentType',
        'ogg_data': :'oggData',
        'deployment_diagnostic_data': :'deploymentDiagnosticData',
        'maintenance_window': :'maintenanceWindow',
        'time_of_next_maintenance': :'timeOfNextMaintenance',
        'next_maintenance_action_type': :'nextMaintenanceActionType',
        'next_maintenance_description': :'nextMaintenanceDescription',
        'maintenance_configuration': :'maintenanceConfiguration',
        'time_ogg_version_supported_until': :'timeOggVersionSupportedUntil',
        'backup_schedule': :'backupSchedule',
        'time_last_backup_scheduled': :'timeLastBackupScheduled',
        'time_next_backup_scheduled': :'timeNextBackupScheduled',
        'ingress_ips': :'ingressIps'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'id': :'String',
        'display_name': :'String',
        'description': :'String',
        'compartment_id': :'String',
        'availability_domain': :'String',
        'fault_domain': :'String',
        'deployment_role': :'String',
        'time_role_changed': :'DateTime',
        'source_deployment_id': :'String',
        'placements': :'Array<OCI::GoldenGate::Models::DeploymentPlacementInfo>',
        'deployment_backup_id': :'String',
        'time_created': :'DateTime',
        'time_updated': :'DateTime',
        'lifecycle_state': :'String',
        'lifecycle_sub_state': :'String',
        'lifecycle_details': :'String',
        'freeform_tags': :'Hash<String, String>',
        'defined_tags': :'Hash<String, Hash<String, Object>>',
        'locks': :'Array<OCI::GoldenGate::Models::ResourceLock>',
        'is_healthy': :'BOOLEAN',
        'subnet_id': :'String',
        'load_balancer_subnet_id': :'String',
        'load_balancer_id': :'String',
        'fqdn': :'String',
        'license_model': :'String',
        'environment_type': :'String',
        'category': :'String',
        'cpu_core_count': :'Integer',
        'is_auto_scaling_enabled': :'BOOLEAN',
        'nsg_ids': :'Array<String>',
        'is_public': :'BOOLEAN',
        'public_ip_address': :'String',
        'private_ip_address': :'String',
        'deployment_url': :'String',
        'system_tags': :'Hash<String, Hash<String, Object>>',
        'is_latest_version': :'BOOLEAN',
        'time_upgrade_required': :'DateTime',
        'storage_utilization_in_bytes': :'Integer',
        'is_storage_utilization_limit_exceeded': :'BOOLEAN',
        'deployment_type': :'String',
        'ogg_data': :'OCI::GoldenGate::Models::OggDeployment',
        'deployment_diagnostic_data': :'OCI::GoldenGate::Models::DeploymentDiagnosticData',
        'maintenance_window': :'OCI::GoldenGate::Models::MaintenanceWindow',
        'time_of_next_maintenance': :'DateTime',
        'next_maintenance_action_type': :'String',
        'next_maintenance_description': :'String',
        'maintenance_configuration': :'OCI::GoldenGate::Models::MaintenanceConfiguration',
        'time_ogg_version_supported_until': :'DateTime',
        'backup_schedule': :'OCI::GoldenGate::Models::BackupSchedule',
        'time_last_backup_scheduled': :'DateTime',
        'time_next_backup_scheduled': :'DateTime',
        'ingress_ips': :'Array<OCI::GoldenGate::Models::IngressIpDetails>'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :id The value to assign to the {#id} property
    # @option attributes [String] :display_name The value to assign to the {#display_name} property
    # @option attributes [String] :description The value to assign to the {#description} property
    # @option attributes [String] :compartment_id The value to assign to the {#compartment_id} property
    # @option attributes [String] :availability_domain The value to assign to the {#availability_domain} property
    # @option attributes [String] :fault_domain The value to assign to the {#fault_domain} property
    # @option attributes [String] :deployment_role The value to assign to the {#deployment_role} property
    # @option attributes [DateTime] :time_role_changed The value to assign to the {#time_role_changed} property
    # @option attributes [String] :source_deployment_id The value to assign to the {#source_deployment_id} property
    # @option attributes [Array<OCI::GoldenGate::Models::DeploymentPlacementInfo>] :placements The value to assign to the {#placements} property
    # @option attributes [String] :deployment_backup_id The value to assign to the {#deployment_backup_id} property
    # @option attributes [DateTime] :time_created The value to assign to the {#time_created} property
    # @option attributes [DateTime] :time_updated The value to assign to the {#time_updated} property
    # @option attributes [String] :lifecycle_state The value to assign to the {#lifecycle_state} property
    # @option attributes [String] :lifecycle_sub_state The value to assign to the {#lifecycle_sub_state} property
    # @option attributes [String] :lifecycle_details The value to assign to the {#lifecycle_details} property
    # @option attributes [Hash<String, String>] :freeform_tags The value to assign to the {#freeform_tags} property
    # @option attributes [Hash<String, Hash<String, Object>>] :defined_tags The value to assign to the {#defined_tags} property
    # @option attributes [Array<OCI::GoldenGate::Models::ResourceLock>] :locks The value to assign to the {#locks} property
    # @option attributes [BOOLEAN] :is_healthy The value to assign to the {#is_healthy} property
    # @option attributes [String] :subnet_id The value to assign to the {#subnet_id} property
    # @option attributes [String] :load_balancer_subnet_id The value to assign to the {#load_balancer_subnet_id} property
    # @option attributes [String] :load_balancer_id The value to assign to the {#load_balancer_id} property
    # @option attributes [String] :fqdn The value to assign to the {#fqdn} property
    # @option attributes [String] :license_model The value to assign to the {#license_model} property
    # @option attributes [String] :environment_type The value to assign to the {#environment_type} property
    # @option attributes [String] :category The value to assign to the {#category} property
    # @option attributes [Integer] :cpu_core_count The value to assign to the {#cpu_core_count} property
    # @option attributes [BOOLEAN] :is_auto_scaling_enabled The value to assign to the {#is_auto_scaling_enabled} property
    # @option attributes [Array<String>] :nsg_ids The value to assign to the {#nsg_ids} property
    # @option attributes [BOOLEAN] :is_public The value to assign to the {#is_public} property
    # @option attributes [String] :public_ip_address The value to assign to the {#public_ip_address} property
    # @option attributes [String] :private_ip_address The value to assign to the {#private_ip_address} property
    # @option attributes [String] :deployment_url The value to assign to the {#deployment_url} property
    # @option attributes [Hash<String, Hash<String, Object>>] :system_tags The value to assign to the {#system_tags} property
    # @option attributes [BOOLEAN] :is_latest_version The value to assign to the {#is_latest_version} property
    # @option attributes [DateTime] :time_upgrade_required The value to assign to the {#time_upgrade_required} property
    # @option attributes [Integer] :storage_utilization_in_bytes The value to assign to the {#storage_utilization_in_bytes} property
    # @option attributes [BOOLEAN] :is_storage_utilization_limit_exceeded The value to assign to the {#is_storage_utilization_limit_exceeded} property
    # @option attributes [String] :deployment_type The value to assign to the {#deployment_type} property
    # @option attributes [OCI::GoldenGate::Models::OggDeployment] :ogg_data The value to assign to the {#ogg_data} property
    # @option attributes [OCI::GoldenGate::Models::DeploymentDiagnosticData] :deployment_diagnostic_data The value to assign to the {#deployment_diagnostic_data} property
    # @option attributes [OCI::GoldenGate::Models::MaintenanceWindow] :maintenance_window The value to assign to the {#maintenance_window} property
    # @option attributes [DateTime] :time_of_next_maintenance The value to assign to the {#time_of_next_maintenance} property
    # @option attributes [String] :next_maintenance_action_type The value to assign to the {#next_maintenance_action_type} property
    # @option attributes [String] :next_maintenance_description The value to assign to the {#next_maintenance_description} property
    # @option attributes [OCI::GoldenGate::Models::MaintenanceConfiguration] :maintenance_configuration The value to assign to the {#maintenance_configuration} property
    # @option attributes [DateTime] :time_ogg_version_supported_until The value to assign to the {#time_ogg_version_supported_until} property
    # @option attributes [OCI::GoldenGate::Models::BackupSchedule] :backup_schedule The value to assign to the {#backup_schedule} property
    # @option attributes [DateTime] :time_last_backup_scheduled The value to assign to the {#time_last_backup_scheduled} property
    # @option attributes [DateTime] :time_next_backup_scheduled The value to assign to the {#time_next_backup_scheduled} property
    # @option attributes [Array<OCI::GoldenGate::Models::IngressIpDetails>] :ingress_ips The value to assign to the {#ingress_ips} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.id = attributes[:'id'] if attributes[:'id']

      self.display_name = attributes[:'displayName'] if attributes[:'displayName']

      raise 'You cannot provide both :displayName and :display_name' if attributes.key?(:'displayName') && attributes.key?(:'display_name')

      self.display_name = attributes[:'display_name'] if attributes[:'display_name']

      self.description = attributes[:'description'] if attributes[:'description']

      self.compartment_id = attributes[:'compartmentId'] if attributes[:'compartmentId']

      raise 'You cannot provide both :compartmentId and :compartment_id' if attributes.key?(:'compartmentId') && attributes.key?(:'compartment_id')

      self.compartment_id = attributes[:'compartment_id'] if attributes[:'compartment_id']

      self.availability_domain = attributes[:'availabilityDomain'] if attributes[:'availabilityDomain']

      raise 'You cannot provide both :availabilityDomain and :availability_domain' if attributes.key?(:'availabilityDomain') && attributes.key?(:'availability_domain')

      self.availability_domain = attributes[:'availability_domain'] if attributes[:'availability_domain']

      self.fault_domain = attributes[:'faultDomain'] if attributes[:'faultDomain']

      raise 'You cannot provide both :faultDomain and :fault_domain' if attributes.key?(:'faultDomain') && attributes.key?(:'fault_domain')

      self.fault_domain = attributes[:'fault_domain'] if attributes[:'fault_domain']

      self.deployment_role = attributes[:'deploymentRole'] if attributes[:'deploymentRole']

      raise 'You cannot provide both :deploymentRole and :deployment_role' if attributes.key?(:'deploymentRole') && attributes.key?(:'deployment_role')

      self.deployment_role = attributes[:'deployment_role'] if attributes[:'deployment_role']

      self.time_role_changed = attributes[:'timeRoleChanged'] if attributes[:'timeRoleChanged']

      raise 'You cannot provide both :timeRoleChanged and :time_role_changed' if attributes.key?(:'timeRoleChanged') && attributes.key?(:'time_role_changed')

      self.time_role_changed = attributes[:'time_role_changed'] if attributes[:'time_role_changed']

      self.source_deployment_id = attributes[:'sourceDeploymentId'] if attributes[:'sourceDeploymentId']

      raise 'You cannot provide both :sourceDeploymentId and :source_deployment_id' if attributes.key?(:'sourceDeploymentId') && attributes.key?(:'source_deployment_id')

      self.source_deployment_id = attributes[:'source_deployment_id'] if attributes[:'source_deployment_id']

      self.placements = attributes[:'placements'] if attributes[:'placements']

      self.deployment_backup_id = attributes[:'deploymentBackupId'] if attributes[:'deploymentBackupId']

      raise 'You cannot provide both :deploymentBackupId and :deployment_backup_id' if attributes.key?(:'deploymentBackupId') && attributes.key?(:'deployment_backup_id')

      self.deployment_backup_id = attributes[:'deployment_backup_id'] if attributes[:'deployment_backup_id']

      self.time_created = attributes[:'timeCreated'] if attributes[:'timeCreated']

      raise 'You cannot provide both :timeCreated and :time_created' if attributes.key?(:'timeCreated') && attributes.key?(:'time_created')

      self.time_created = attributes[:'time_created'] if attributes[:'time_created']

      self.time_updated = attributes[:'timeUpdated'] if attributes[:'timeUpdated']

      raise 'You cannot provide both :timeUpdated and :time_updated' if attributes.key?(:'timeUpdated') && attributes.key?(:'time_updated')

      self.time_updated = attributes[:'time_updated'] if attributes[:'time_updated']

      self.lifecycle_state = attributes[:'lifecycleState'] if attributes[:'lifecycleState']

      raise 'You cannot provide both :lifecycleState and :lifecycle_state' if attributes.key?(:'lifecycleState') && attributes.key?(:'lifecycle_state')

      self.lifecycle_state = attributes[:'lifecycle_state'] if attributes[:'lifecycle_state']

      self.lifecycle_sub_state = attributes[:'lifecycleSubState'] if attributes[:'lifecycleSubState']

      raise 'You cannot provide both :lifecycleSubState and :lifecycle_sub_state' if attributes.key?(:'lifecycleSubState') && attributes.key?(:'lifecycle_sub_state')

      self.lifecycle_sub_state = attributes[:'lifecycle_sub_state'] if attributes[:'lifecycle_sub_state']

      self.lifecycle_details = attributes[:'lifecycleDetails'] if attributes[:'lifecycleDetails']

      raise 'You cannot provide both :lifecycleDetails and :lifecycle_details' if attributes.key?(:'lifecycleDetails') && attributes.key?(:'lifecycle_details')

      self.lifecycle_details = attributes[:'lifecycle_details'] if attributes[:'lifecycle_details']

      self.freeform_tags = attributes[:'freeformTags'] if attributes[:'freeformTags']

      raise 'You cannot provide both :freeformTags and :freeform_tags' if attributes.key?(:'freeformTags') && attributes.key?(:'freeform_tags')

      self.freeform_tags = attributes[:'freeform_tags'] if attributes[:'freeform_tags']

      self.defined_tags = attributes[:'definedTags'] if attributes[:'definedTags']

      raise 'You cannot provide both :definedTags and :defined_tags' if attributes.key?(:'definedTags') && attributes.key?(:'defined_tags')

      self.defined_tags = attributes[:'defined_tags'] if attributes[:'defined_tags']

      self.locks = attributes[:'locks'] if attributes[:'locks']

      self.is_healthy = attributes[:'isHealthy'] unless attributes[:'isHealthy'].nil?

      raise 'You cannot provide both :isHealthy and :is_healthy' if attributes.key?(:'isHealthy') && attributes.key?(:'is_healthy')

      self.is_healthy = attributes[:'is_healthy'] unless attributes[:'is_healthy'].nil?

      self.subnet_id = attributes[:'subnetId'] if attributes[:'subnetId']

      raise 'You cannot provide both :subnetId and :subnet_id' if attributes.key?(:'subnetId') && attributes.key?(:'subnet_id')

      self.subnet_id = attributes[:'subnet_id'] if attributes[:'subnet_id']

      self.load_balancer_subnet_id = attributes[:'loadBalancerSubnetId'] if attributes[:'loadBalancerSubnetId']

      raise 'You cannot provide both :loadBalancerSubnetId and :load_balancer_subnet_id' if attributes.key?(:'loadBalancerSubnetId') && attributes.key?(:'load_balancer_subnet_id')

      self.load_balancer_subnet_id = attributes[:'load_balancer_subnet_id'] if attributes[:'load_balancer_subnet_id']

      self.load_balancer_id = attributes[:'loadBalancerId'] if attributes[:'loadBalancerId']

      raise 'You cannot provide both :loadBalancerId and :load_balancer_id' if attributes.key?(:'loadBalancerId') && attributes.key?(:'load_balancer_id')

      self.load_balancer_id = attributes[:'load_balancer_id'] if attributes[:'load_balancer_id']

      self.fqdn = attributes[:'fqdn'] if attributes[:'fqdn']

      self.license_model = attributes[:'licenseModel'] if attributes[:'licenseModel']

      raise 'You cannot provide both :licenseModel and :license_model' if attributes.key?(:'licenseModel') && attributes.key?(:'license_model')

      self.license_model = attributes[:'license_model'] if attributes[:'license_model']

      self.environment_type = attributes[:'environmentType'] if attributes[:'environmentType']

      raise 'You cannot provide both :environmentType and :environment_type' if attributes.key?(:'environmentType') && attributes.key?(:'environment_type')

      self.environment_type = attributes[:'environment_type'] if attributes[:'environment_type']

      self.category = attributes[:'category'] if attributes[:'category']

      self.cpu_core_count = attributes[:'cpuCoreCount'] if attributes[:'cpuCoreCount']

      raise 'You cannot provide both :cpuCoreCount and :cpu_core_count' if attributes.key?(:'cpuCoreCount') && attributes.key?(:'cpu_core_count')

      self.cpu_core_count = attributes[:'cpu_core_count'] if attributes[:'cpu_core_count']

      self.is_auto_scaling_enabled = attributes[:'isAutoScalingEnabled'] unless attributes[:'isAutoScalingEnabled'].nil?

      raise 'You cannot provide both :isAutoScalingEnabled and :is_auto_scaling_enabled' if attributes.key?(:'isAutoScalingEnabled') && attributes.key?(:'is_auto_scaling_enabled')

      self.is_auto_scaling_enabled = attributes[:'is_auto_scaling_enabled'] unless attributes[:'is_auto_scaling_enabled'].nil?

      self.nsg_ids = attributes[:'nsgIds'] if attributes[:'nsgIds']

      raise 'You cannot provide both :nsgIds and :nsg_ids' if attributes.key?(:'nsgIds') && attributes.key?(:'nsg_ids')

      self.nsg_ids = attributes[:'nsg_ids'] if attributes[:'nsg_ids']

      self.is_public = attributes[:'isPublic'] unless attributes[:'isPublic'].nil?

      raise 'You cannot provide both :isPublic and :is_public' if attributes.key?(:'isPublic') && attributes.key?(:'is_public')

      self.is_public = attributes[:'is_public'] unless attributes[:'is_public'].nil?

      self.public_ip_address = attributes[:'publicIpAddress'] if attributes[:'publicIpAddress']

      raise 'You cannot provide both :publicIpAddress and :public_ip_address' if attributes.key?(:'publicIpAddress') && attributes.key?(:'public_ip_address')

      self.public_ip_address = attributes[:'public_ip_address'] if attributes[:'public_ip_address']

      self.private_ip_address = attributes[:'privateIpAddress'] if attributes[:'privateIpAddress']

      raise 'You cannot provide both :privateIpAddress and :private_ip_address' if attributes.key?(:'privateIpAddress') && attributes.key?(:'private_ip_address')

      self.private_ip_address = attributes[:'private_ip_address'] if attributes[:'private_ip_address']

      self.deployment_url = attributes[:'deploymentUrl'] if attributes[:'deploymentUrl']

      raise 'You cannot provide both :deploymentUrl and :deployment_url' if attributes.key?(:'deploymentUrl') && attributes.key?(:'deployment_url')

      self.deployment_url = attributes[:'deployment_url'] if attributes[:'deployment_url']

      self.system_tags = attributes[:'systemTags'] if attributes[:'systemTags']

      raise 'You cannot provide both :systemTags and :system_tags' if attributes.key?(:'systemTags') && attributes.key?(:'system_tags')

      self.system_tags = attributes[:'system_tags'] if attributes[:'system_tags']

      self.is_latest_version = attributes[:'isLatestVersion'] unless attributes[:'isLatestVersion'].nil?

      raise 'You cannot provide both :isLatestVersion and :is_latest_version' if attributes.key?(:'isLatestVersion') && attributes.key?(:'is_latest_version')

      self.is_latest_version = attributes[:'is_latest_version'] unless attributes[:'is_latest_version'].nil?

      self.time_upgrade_required = attributes[:'timeUpgradeRequired'] if attributes[:'timeUpgradeRequired']

      raise 'You cannot provide both :timeUpgradeRequired and :time_upgrade_required' if attributes.key?(:'timeUpgradeRequired') && attributes.key?(:'time_upgrade_required')

      self.time_upgrade_required = attributes[:'time_upgrade_required'] if attributes[:'time_upgrade_required']

      self.storage_utilization_in_bytes = attributes[:'storageUtilizationInBytes'] if attributes[:'storageUtilizationInBytes']

      raise 'You cannot provide both :storageUtilizationInBytes and :storage_utilization_in_bytes' if attributes.key?(:'storageUtilizationInBytes') && attributes.key?(:'storage_utilization_in_bytes')

      self.storage_utilization_in_bytes = attributes[:'storage_utilization_in_bytes'] if attributes[:'storage_utilization_in_bytes']

      self.is_storage_utilization_limit_exceeded = attributes[:'isStorageUtilizationLimitExceeded'] unless attributes[:'isStorageUtilizationLimitExceeded'].nil?

      raise 'You cannot provide both :isStorageUtilizationLimitExceeded and :is_storage_utilization_limit_exceeded' if attributes.key?(:'isStorageUtilizationLimitExceeded') && attributes.key?(:'is_storage_utilization_limit_exceeded')

      self.is_storage_utilization_limit_exceeded = attributes[:'is_storage_utilization_limit_exceeded'] unless attributes[:'is_storage_utilization_limit_exceeded'].nil?

      self.deployment_type = attributes[:'deploymentType'] if attributes[:'deploymentType']

      raise 'You cannot provide both :deploymentType and :deployment_type' if attributes.key?(:'deploymentType') && attributes.key?(:'deployment_type')

      self.deployment_type = attributes[:'deployment_type'] if attributes[:'deployment_type']

      self.ogg_data = attributes[:'oggData'] if attributes[:'oggData']

      raise 'You cannot provide both :oggData and :ogg_data' if attributes.key?(:'oggData') && attributes.key?(:'ogg_data')

      self.ogg_data = attributes[:'ogg_data'] if attributes[:'ogg_data']

      self.deployment_diagnostic_data = attributes[:'deploymentDiagnosticData'] if attributes[:'deploymentDiagnosticData']

      raise 'You cannot provide both :deploymentDiagnosticData and :deployment_diagnostic_data' if attributes.key?(:'deploymentDiagnosticData') && attributes.key?(:'deployment_diagnostic_data')

      self.deployment_diagnostic_data = attributes[:'deployment_diagnostic_data'] if attributes[:'deployment_diagnostic_data']

      self.maintenance_window = attributes[:'maintenanceWindow'] if attributes[:'maintenanceWindow']

      raise 'You cannot provide both :maintenanceWindow and :maintenance_window' if attributes.key?(:'maintenanceWindow') && attributes.key?(:'maintenance_window')

      self.maintenance_window = attributes[:'maintenance_window'] if attributes[:'maintenance_window']

      self.time_of_next_maintenance = attributes[:'timeOfNextMaintenance'] if attributes[:'timeOfNextMaintenance']

      raise 'You cannot provide both :timeOfNextMaintenance and :time_of_next_maintenance' if attributes.key?(:'timeOfNextMaintenance') && attributes.key?(:'time_of_next_maintenance')

      self.time_of_next_maintenance = attributes[:'time_of_next_maintenance'] if attributes[:'time_of_next_maintenance']

      self.next_maintenance_action_type = attributes[:'nextMaintenanceActionType'] if attributes[:'nextMaintenanceActionType']

      raise 'You cannot provide both :nextMaintenanceActionType and :next_maintenance_action_type' if attributes.key?(:'nextMaintenanceActionType') && attributes.key?(:'next_maintenance_action_type')

      self.next_maintenance_action_type = attributes[:'next_maintenance_action_type'] if attributes[:'next_maintenance_action_type']

      self.next_maintenance_description = attributes[:'nextMaintenanceDescription'] if attributes[:'nextMaintenanceDescription']

      raise 'You cannot provide both :nextMaintenanceDescription and :next_maintenance_description' if attributes.key?(:'nextMaintenanceDescription') && attributes.key?(:'next_maintenance_description')

      self.next_maintenance_description = attributes[:'next_maintenance_description'] if attributes[:'next_maintenance_description']

      self.maintenance_configuration = attributes[:'maintenanceConfiguration'] if attributes[:'maintenanceConfiguration']

      raise 'You cannot provide both :maintenanceConfiguration and :maintenance_configuration' if attributes.key?(:'maintenanceConfiguration') && attributes.key?(:'maintenance_configuration')

      self.maintenance_configuration = attributes[:'maintenance_configuration'] if attributes[:'maintenance_configuration']

      self.time_ogg_version_supported_until = attributes[:'timeOggVersionSupportedUntil'] if attributes[:'timeOggVersionSupportedUntil']

      raise 'You cannot provide both :timeOggVersionSupportedUntil and :time_ogg_version_supported_until' if attributes.key?(:'timeOggVersionSupportedUntil') && attributes.key?(:'time_ogg_version_supported_until')

      self.time_ogg_version_supported_until = attributes[:'time_ogg_version_supported_until'] if attributes[:'time_ogg_version_supported_until']

      self.backup_schedule = attributes[:'backupSchedule'] if attributes[:'backupSchedule']

      raise 'You cannot provide both :backupSchedule and :backup_schedule' if attributes.key?(:'backupSchedule') && attributes.key?(:'backup_schedule')

      self.backup_schedule = attributes[:'backup_schedule'] if attributes[:'backup_schedule']

      self.time_last_backup_scheduled = attributes[:'timeLastBackupScheduled'] if attributes[:'timeLastBackupScheduled']

      raise 'You cannot provide both :timeLastBackupScheduled and :time_last_backup_scheduled' if attributes.key?(:'timeLastBackupScheduled') && attributes.key?(:'time_last_backup_scheduled')

      self.time_last_backup_scheduled = attributes[:'time_last_backup_scheduled'] if attributes[:'time_last_backup_scheduled']

      self.time_next_backup_scheduled = attributes[:'timeNextBackupScheduled'] if attributes[:'timeNextBackupScheduled']

      raise 'You cannot provide both :timeNextBackupScheduled and :time_next_backup_scheduled' if attributes.key?(:'timeNextBackupScheduled') && attributes.key?(:'time_next_backup_scheduled')

      self.time_next_backup_scheduled = attributes[:'time_next_backup_scheduled'] if attributes[:'time_next_backup_scheduled']

      self.ingress_ips = attributes[:'ingressIps'] if attributes[:'ingressIps']

      raise 'You cannot provide both :ingressIps and :ingress_ips' if attributes.key?(:'ingressIps') && attributes.key?(:'ingress_ips')

      self.ingress_ips = attributes[:'ingress_ips'] if attributes[:'ingress_ips']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] deployment_role Object to be assigned
    def deployment_role=(deployment_role)
      # rubocop:disable Style/ConditionalAssignment
      if deployment_role && !DEPLOYMENT_ROLE_ENUM.include?(deployment_role)
        OCI.logger.debug("Unknown value for 'deployment_role' [" + deployment_role + "]. Mapping to 'DEPLOYMENT_ROLE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @deployment_role = DEPLOYMENT_ROLE_UNKNOWN_ENUM_VALUE
      else
        @deployment_role = deployment_role
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] lifecycle_state Object to be assigned
    def lifecycle_state=(lifecycle_state)
      # rubocop:disable Style/ConditionalAssignment
      if lifecycle_state && !LIFECYCLE_STATE_ENUM.include?(lifecycle_state)
        OCI.logger.debug("Unknown value for 'lifecycle_state' [" + lifecycle_state + "]. Mapping to 'LIFECYCLE_STATE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @lifecycle_state = LIFECYCLE_STATE_UNKNOWN_ENUM_VALUE
      else
        @lifecycle_state = lifecycle_state
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] lifecycle_sub_state Object to be assigned
    def lifecycle_sub_state=(lifecycle_sub_state)
      # rubocop:disable Style/ConditionalAssignment
      if lifecycle_sub_state && !LIFECYCLE_SUB_STATE_ENUM.include?(lifecycle_sub_state)
        OCI.logger.debug("Unknown value for 'lifecycle_sub_state' [" + lifecycle_sub_state + "]. Mapping to 'LIFECYCLE_SUB_STATE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @lifecycle_sub_state = LIFECYCLE_SUB_STATE_UNKNOWN_ENUM_VALUE
      else
        @lifecycle_sub_state = lifecycle_sub_state
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] license_model Object to be assigned
    def license_model=(license_model)
      # rubocop:disable Style/ConditionalAssignment
      if license_model && !LICENSE_MODEL_ENUM.include?(license_model)
        OCI.logger.debug("Unknown value for 'license_model' [" + license_model + "]. Mapping to 'LICENSE_MODEL_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @license_model = LICENSE_MODEL_UNKNOWN_ENUM_VALUE
      else
        @license_model = license_model
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] environment_type Object to be assigned
    def environment_type=(environment_type)
      # rubocop:disable Style/ConditionalAssignment
      if environment_type && !ENVIRONMENT_TYPE_ENUM.include?(environment_type)
        OCI.logger.debug("Unknown value for 'environment_type' [" + environment_type + "]. Mapping to 'ENVIRONMENT_TYPE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @environment_type = ENVIRONMENT_TYPE_UNKNOWN_ENUM_VALUE
      else
        @environment_type = environment_type
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] category Object to be assigned
    def category=(category)
      # rubocop:disable Style/ConditionalAssignment
      if category && !CATEGORY_ENUM.include?(category)
        OCI.logger.debug("Unknown value for 'category' [" + category + "]. Mapping to 'CATEGORY_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @category = CATEGORY_UNKNOWN_ENUM_VALUE
      else
        @category = category
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] deployment_type Object to be assigned
    def deployment_type=(deployment_type)
      # rubocop:disable Style/ConditionalAssignment
      if deployment_type && !DEPLOYMENT_TYPE_ENUM.include?(deployment_type)
        OCI.logger.debug("Unknown value for 'deployment_type' [" + deployment_type + "]. Mapping to 'DEPLOYMENT_TYPE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @deployment_type = DEPLOYMENT_TYPE_UNKNOWN_ENUM_VALUE
      else
        @deployment_type = deployment_type
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] next_maintenance_action_type Object to be assigned
    def next_maintenance_action_type=(next_maintenance_action_type)
      # rubocop:disable Style/ConditionalAssignment
      if next_maintenance_action_type && !NEXT_MAINTENANCE_ACTION_TYPE_ENUM.include?(next_maintenance_action_type)
        OCI.logger.debug("Unknown value for 'next_maintenance_action_type' [" + next_maintenance_action_type + "]. Mapping to 'NEXT_MAINTENANCE_ACTION_TYPE_UNKNOWN_ENUM_VALUE'") if OCI.logger
        @next_maintenance_action_type = NEXT_MAINTENANCE_ACTION_TYPE_UNKNOWN_ENUM_VALUE
      else
        @next_maintenance_action_type = next_maintenance_action_type
      end
      # rubocop:enable Style/ConditionalAssignment
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        id == other.id &&
        display_name == other.display_name &&
        description == other.description &&
        compartment_id == other.compartment_id &&
        availability_domain == other.availability_domain &&
        fault_domain == other.fault_domain &&
        deployment_role == other.deployment_role &&
        time_role_changed == other.time_role_changed &&
        source_deployment_id == other.source_deployment_id &&
        placements == other.placements &&
        deployment_backup_id == other.deployment_backup_id &&
        time_created == other.time_created &&
        time_updated == other.time_updated &&
        lifecycle_state == other.lifecycle_state &&
        lifecycle_sub_state == other.lifecycle_sub_state &&
        lifecycle_details == other.lifecycle_details &&
        freeform_tags == other.freeform_tags &&
        defined_tags == other.defined_tags &&
        locks == other.locks &&
        is_healthy == other.is_healthy &&
        subnet_id == other.subnet_id &&
        load_balancer_subnet_id == other.load_balancer_subnet_id &&
        load_balancer_id == other.load_balancer_id &&
        fqdn == other.fqdn &&
        license_model == other.license_model &&
        environment_type == other.environment_type &&
        category == other.category &&
        cpu_core_count == other.cpu_core_count &&
        is_auto_scaling_enabled == other.is_auto_scaling_enabled &&
        nsg_ids == other.nsg_ids &&
        is_public == other.is_public &&
        public_ip_address == other.public_ip_address &&
        private_ip_address == other.private_ip_address &&
        deployment_url == other.deployment_url &&
        system_tags == other.system_tags &&
        is_latest_version == other.is_latest_version &&
        time_upgrade_required == other.time_upgrade_required &&
        storage_utilization_in_bytes == other.storage_utilization_in_bytes &&
        is_storage_utilization_limit_exceeded == other.is_storage_utilization_limit_exceeded &&
        deployment_type == other.deployment_type &&
        ogg_data == other.ogg_data &&
        deployment_diagnostic_data == other.deployment_diagnostic_data &&
        maintenance_window == other.maintenance_window &&
        time_of_next_maintenance == other.time_of_next_maintenance &&
        next_maintenance_action_type == other.next_maintenance_action_type &&
        next_maintenance_description == other.next_maintenance_description &&
        maintenance_configuration == other.maintenance_configuration &&
        time_ogg_version_supported_until == other.time_ogg_version_supported_until &&
        backup_schedule == other.backup_schedule &&
        time_last_backup_scheduled == other.time_last_backup_scheduled &&
        time_next_backup_scheduled == other.time_next_backup_scheduled &&
        ingress_ips == other.ingress_ips
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, display_name, description, compartment_id, availability_domain, fault_domain, deployment_role, time_role_changed, source_deployment_id, placements, deployment_backup_id, time_created, time_updated, lifecycle_state, lifecycle_sub_state, lifecycle_details, freeform_tags, defined_tags, locks, is_healthy, subnet_id, load_balancer_subnet_id, load_balancer_id, fqdn, license_model, environment_type, category, cpu_core_count, is_auto_scaling_enabled, nsg_ids, is_public, public_ip_address, private_ip_address, deployment_url, system_tags, is_latest_version, time_upgrade_required, storage_utilization_in_bytes, is_storage_utilization_limit_exceeded, deployment_type, ogg_data, deployment_diagnostic_data, maintenance_window, time_of_next_maintenance, next_maintenance_action_type, next_maintenance_description, maintenance_configuration, time_ogg_version_supported_until, backup_schedule, time_last_backup_scheduled, time_next_backup_scheduled, ingress_ips].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
