# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210610
require 'date'
require_relative 'work_item_details'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The work item details for deployed application related information.
  class Jms::Models::DeployedApplicationWorkItemDetails < Jms::Models::WorkItemDetails
    # **[Required]** The unique key of the deployed application.
    # @return [String]
    attr_accessor :deployed_application_key

    # The unique key of the deployed application installation.
    # @return [String]
    attr_accessor :deployed_application_installation_key

    # **[Required]** The deployed application name.
    # @return [String]
    attr_accessor :deployed_application_name

    # The full path on which deployed application installation was detected.
    # @return [String]
    attr_accessor :deployed_application_installation_path

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'kind': :'kind',
        'work_item_type': :'workItemType',
        'deployed_application_key': :'deployedApplicationKey',
        'deployed_application_installation_key': :'deployedApplicationInstallationKey',
        'deployed_application_name': :'deployedApplicationName',
        'deployed_application_installation_path': :'deployedApplicationInstallationPath'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'kind': :'String',
        'work_item_type': :'String',
        'deployed_application_key': :'String',
        'deployed_application_installation_key': :'String',
        'deployed_application_name': :'String',
        'deployed_application_installation_path': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :work_item_type The value to assign to the {OCI::Jms::Models::WorkItemDetails#work_item_type #work_item_type} proprety
    # @option attributes [String] :deployed_application_key The value to assign to the {#deployed_application_key} property
    # @option attributes [String] :deployed_application_installation_key The value to assign to the {#deployed_application_installation_key} property
    # @option attributes [String] :deployed_application_name The value to assign to the {#deployed_application_name} property
    # @option attributes [String] :deployed_application_installation_path The value to assign to the {#deployed_application_installation_path} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      attributes['kind'] = 'DEPLOYED_APPLICATION'

      super(attributes)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.deployed_application_key = attributes[:'deployedApplicationKey'] if attributes[:'deployedApplicationKey']

      raise 'You cannot provide both :deployedApplicationKey and :deployed_application_key' if attributes.key?(:'deployedApplicationKey') && attributes.key?(:'deployed_application_key')

      self.deployed_application_key = attributes[:'deployed_application_key'] if attributes[:'deployed_application_key']

      self.deployed_application_installation_key = attributes[:'deployedApplicationInstallationKey'] if attributes[:'deployedApplicationInstallationKey']

      raise 'You cannot provide both :deployedApplicationInstallationKey and :deployed_application_installation_key' if attributes.key?(:'deployedApplicationInstallationKey') && attributes.key?(:'deployed_application_installation_key')

      self.deployed_application_installation_key = attributes[:'deployed_application_installation_key'] if attributes[:'deployed_application_installation_key']

      self.deployed_application_name = attributes[:'deployedApplicationName'] if attributes[:'deployedApplicationName']

      raise 'You cannot provide both :deployedApplicationName and :deployed_application_name' if attributes.key?(:'deployedApplicationName') && attributes.key?(:'deployed_application_name')

      self.deployed_application_name = attributes[:'deployed_application_name'] if attributes[:'deployed_application_name']

      self.deployed_application_installation_path = attributes[:'deployedApplicationInstallationPath'] if attributes[:'deployedApplicationInstallationPath']

      raise 'You cannot provide both :deployedApplicationInstallationPath and :deployed_application_installation_path' if attributes.key?(:'deployedApplicationInstallationPath') && attributes.key?(:'deployed_application_installation_path')

      self.deployed_application_installation_path = attributes[:'deployed_application_installation_path'] if attributes[:'deployed_application_installation_path']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        kind == other.kind &&
        work_item_type == other.work_item_type &&
        deployed_application_key == other.deployed_application_key &&
        deployed_application_installation_key == other.deployed_application_installation_key &&
        deployed_application_name == other.deployed_application_name &&
        deployed_application_installation_path == other.deployed_application_installation_path
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [kind, work_item_type, deployed_application_key, deployed_application_installation_key, deployed_application_name, deployed_application_installation_path].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
