# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20250320
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # The data to update an order in MAC_ORDER bucket.
  class Mngdmac::Models::OpsActionUpdateMacOrderDetails
    # The new status of the MacOrder.
    # @return [String]
    attr_accessor :order_status

    # The IP Range specified by the customer for this order.
    # @return [String]
    attr_accessor :ip_range

    # The date and time this mac order is Active from. An RFC3339 formatted datetime string.
    # @return [DateTime]
    attr_accessor :time_billing_started

    # The date and time this mac order until which this mac is Active. An RFC3339 formatted datetime string.
    # @return [DateTime]
    attr_accessor :time_billing_ended

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'order_status': :'orderStatus',
        'ip_range': :'ipRange',
        'time_billing_started': :'timeBillingStarted',
        'time_billing_ended': :'timeBillingEnded'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'order_status': :'String',
        'ip_range': :'String',
        'time_billing_started': :'DateTime',
        'time_billing_ended': :'DateTime'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :order_status The value to assign to the {#order_status} property
    # @option attributes [String] :ip_range The value to assign to the {#ip_range} property
    # @option attributes [DateTime] :time_billing_started The value to assign to the {#time_billing_started} property
    # @option attributes [DateTime] :time_billing_ended The value to assign to the {#time_billing_ended} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.order_status = attributes[:'orderStatus'] if attributes[:'orderStatus']

      raise 'You cannot provide both :orderStatus and :order_status' if attributes.key?(:'orderStatus') && attributes.key?(:'order_status')

      self.order_status = attributes[:'order_status'] if attributes[:'order_status']

      self.ip_range = attributes[:'ipRange'] if attributes[:'ipRange']

      raise 'You cannot provide both :ipRange and :ip_range' if attributes.key?(:'ipRange') && attributes.key?(:'ip_range')

      self.ip_range = attributes[:'ip_range'] if attributes[:'ip_range']

      self.time_billing_started = attributes[:'timeBillingStarted'] if attributes[:'timeBillingStarted']

      raise 'You cannot provide both :timeBillingStarted and :time_billing_started' if attributes.key?(:'timeBillingStarted') && attributes.key?(:'time_billing_started')

      self.time_billing_started = attributes[:'time_billing_started'] if attributes[:'time_billing_started']

      self.time_billing_ended = attributes[:'timeBillingEnded'] if attributes[:'timeBillingEnded']

      raise 'You cannot provide both :timeBillingEnded and :time_billing_ended' if attributes.key?(:'timeBillingEnded') && attributes.key?(:'time_billing_ended')

      self.time_billing_ended = attributes[:'time_billing_ended'] if attributes[:'time_billing_ended']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        order_status == other.order_status &&
        ip_range == other.ip_range &&
        time_billing_started == other.time_billing_started &&
        time_billing_ended == other.time_billing_ended
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [order_status, ip_range, time_billing_started, time_billing_ended].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
