# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20160918
require 'date'

# rubocop:disable Lint/UnneededCopDisableDirective, Metrics/LineLength
module OCI
  # An object containing FQDNs
  #
  class ObjectStorage::Models::PrefixFqdns
    # ObjectStorage API FQDN
    #
    # @return [String]
    attr_accessor :object_storage_api_fqdn

    # S3 Compatibility API FQDN
    #
    # @return [String]
    attr_accessor :s3_compatibility_api_fqdn

    # Swift API FQDN
    #
    # @return [String]
    attr_accessor :swift_api_fqdn

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        # rubocop:disable Style/SymbolLiteral
        'object_storage_api_fqdn': :'objectStorageApiFqdn',
        's3_compatibility_api_fqdn': :'s3CompatibilityApiFqdn',
        'swift_api_fqdn': :'swiftApiFqdn'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        # rubocop:disable Style/SymbolLiteral
        'object_storage_api_fqdn': :'String',
        's3_compatibility_api_fqdn': :'String',
        'swift_api_fqdn': :'String'
        # rubocop:enable Style/SymbolLiteral
      }
    end

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:disable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral


    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    # @option attributes [String] :object_storage_api_fqdn The value to assign to the {#object_storage_api_fqdn} property
    # @option attributes [String] :s3_compatibility_api_fqdn The value to assign to the {#s3_compatibility_api_fqdn} property
    # @option attributes [String] :swift_api_fqdn The value to assign to the {#swift_api_fqdn} property
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      self.object_storage_api_fqdn = attributes[:'objectStorageApiFqdn'] if attributes[:'objectStorageApiFqdn']

      raise 'You cannot provide both :objectStorageApiFqdn and :object_storage_api_fqdn' if attributes.key?(:'objectStorageApiFqdn') && attributes.key?(:'object_storage_api_fqdn')

      self.object_storage_api_fqdn = attributes[:'object_storage_api_fqdn'] if attributes[:'object_storage_api_fqdn']

      self.s3_compatibility_api_fqdn = attributes[:'s3CompatibilityApiFqdn'] if attributes[:'s3CompatibilityApiFqdn']

      raise 'You cannot provide both :s3CompatibilityApiFqdn and :s3_compatibility_api_fqdn' if attributes.key?(:'s3CompatibilityApiFqdn') && attributes.key?(:'s3_compatibility_api_fqdn')

      self.s3_compatibility_api_fqdn = attributes[:'s3_compatibility_api_fqdn'] if attributes[:'s3_compatibility_api_fqdn']

      self.swift_api_fqdn = attributes[:'swiftApiFqdn'] if attributes[:'swiftApiFqdn']

      raise 'You cannot provide both :swiftApiFqdn and :swift_api_fqdn' if attributes.key?(:'swiftApiFqdn') && attributes.key?(:'swift_api_fqdn')

      self.swift_api_fqdn = attributes[:'swift_api_fqdn'] if attributes[:'swift_api_fqdn']
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity
    # rubocop:enable Metrics/MethodLength, Layout/EmptyLines, Style/SymbolLiteral

    # rubocop:disable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines


    # Checks equality by comparing each attribute.
    # @param [Object] other the other object to be compared
    def ==(other)
      return true if equal?(other)

      self.class == other.class &&
        object_storage_api_fqdn == other.object_storage_api_fqdn &&
        s3_compatibility_api_fqdn == other.s3_compatibility_api_fqdn &&
        swift_api_fqdn == other.swift_api_fqdn
    end
    # rubocop:enable Metrics/CyclomaticComplexity, Metrics/AbcSize, Metrics/PerceivedComplexity, Layout/EmptyLines

    # @see the `==` method
    # @param [Object] other the other object to be compared
    def eql?(other)
      self == other
    end

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [object_storage_api_fqdn, s3_compatibility_api_fqdn, swift_api_fqdn].hash
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # rubocop:disable Metrics/AbcSize, Layout/EmptyLines


    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)

      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            public_method("#{key}=").call(
              attributes[self.class.attribute_map[key]]
                .map { |v| OCI::Internal::Util.convert_to_type(Regexp.last_match(1), v) }
            )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          public_method("#{key}=").call(
            OCI::Internal::Util.convert_to_type(type, attributes[self.class.attribute_map[key]])
          )
        end
        # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end
    # rubocop:enable Metrics/AbcSize, Layout/EmptyLines

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = public_method(attr).call
        next if value.nil? && !instance_variable_defined?("@#{attr}")

        hash[param] = _to_hash(value)
      end
      hash
    end

    private

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
# rubocop:enable Lint/UnneededCopDisableDirective, Metrics/LineLength
