# Copyright (c) 2016, 2025, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20210330

module OCI
  module StackMonitoring
    # Module containing models for requests made to, and responses received from,
    # OCI StackMonitoring services
    module Models
    end
  end
end

# Require models
require 'oci/stack_monitoring/models/action_type'
require 'oci/stack_monitoring/models/additional_configuration_details'
require 'oci/stack_monitoring/models/agent_extension_handler_configuration'
require 'oci/stack_monitoring/models/agent_extension_handler_configuration_property'
require 'oci/stack_monitoring/models/agent_extension_handler_metric_mapping_details'
require 'oci/stack_monitoring/models/agent_receiver_properties'
require 'oci/stack_monitoring/models/alarm_condition'
require 'oci/stack_monitoring/models/alarm_condition_collection'
require 'oci/stack_monitoring/models/alarm_condition_life_cycle_details'
require 'oci/stack_monitoring/models/alarm_condition_life_cycle_states'
require 'oci/stack_monitoring/models/alarm_condition_severity'
require 'oci/stack_monitoring/models/alarm_condition_summary'
require 'oci/stack_monitoring/models/anomaly_data_point'
require 'oci/stack_monitoring/models/anomaly_metric_data'
require 'oci/stack_monitoring/models/associate_monitored_resources_details'
require 'oci/stack_monitoring/models/associated_monitored_resource'
require 'oci/stack_monitoring/models/associated_resources_collection'
require 'oci/stack_monitoring/models/associated_resources_summary'
require 'oci/stack_monitoring/models/association_details'
require 'oci/stack_monitoring/models/association_resource_details'
require 'oci/stack_monitoring/models/auto_promote_config_details'
require 'oci/stack_monitoring/models/auto_promote_config_summary'
require 'oci/stack_monitoring/models/availability_metrics_details'
require 'oci/stack_monitoring/models/baselineable_metric'
require 'oci/stack_monitoring/models/baselineable_metric_life_cycle_states'
require 'oci/stack_monitoring/models/baselineable_metric_summary'
require 'oci/stack_monitoring/models/baselineable_metric_summary_collection'
require 'oci/stack_monitoring/models/change_config_compartment_details'
require 'oci/stack_monitoring/models/change_metric_extension_compartment_details'
require 'oci/stack_monitoring/models/change_monitored_resource_compartment_details'
require 'oci/stack_monitoring/models/change_monitored_resource_task_compartment_details'
require 'oci/stack_monitoring/models/change_process_set_compartment_details'
require 'oci/stack_monitoring/models/collectd_resource_name_configuration_details'
require 'oci/stack_monitoring/models/compute_auto_activate_plugin_config_details'
require 'oci/stack_monitoring/models/compute_auto_activate_plugin_config_summary'
require 'oci/stack_monitoring/models/condition'
require 'oci/stack_monitoring/models/condition_type'
require 'oci/stack_monitoring/models/config'
require 'oci/stack_monitoring/models/config_collection'
require 'oci/stack_monitoring/models/config_summary'
require 'oci/stack_monitoring/models/connection_details'
require 'oci/stack_monitoring/models/create_alarm_condition_details'
require 'oci/stack_monitoring/models/create_auto_promote_config_details'
require 'oci/stack_monitoring/models/create_baselineable_metric_details'
require 'oci/stack_monitoring/models/create_compute_auto_activate_plugin_config_details'
require 'oci/stack_monitoring/models/create_config_details'
require 'oci/stack_monitoring/models/create_discovery_job_details'
require 'oci/stack_monitoring/models/create_license_auto_assign_config_details'
require 'oci/stack_monitoring/models/create_license_enterprise_extensibility_config_details'
require 'oci/stack_monitoring/models/create_maintenance_window_details'
require 'oci/stack_monitoring/models/create_maintenance_window_resource_details'
require 'oci/stack_monitoring/models/create_metric_extension_details'
require 'oci/stack_monitoring/models/create_monitored_resource_details'
require 'oci/stack_monitoring/models/create_monitored_resource_task_details'
require 'oci/stack_monitoring/models/create_monitored_resource_type_details'
require 'oci/stack_monitoring/models/create_monitoring_template_details'
require 'oci/stack_monitoring/models/create_onboard_config_details'
require 'oci/stack_monitoring/models/create_process_set_details'
require 'oci/stack_monitoring/models/credential_collection'
require 'oci/stack_monitoring/models/credential_details'
require 'oci/stack_monitoring/models/credential_property'
require 'oci/stack_monitoring/models/data_point'
require 'oci/stack_monitoring/models/defined_alarm_condition'
require 'oci/stack_monitoring/models/defined_monitoring_template_collection'
require 'oci/stack_monitoring/models/defined_monitoring_template_summary'
require 'oci/stack_monitoring/models/disable_metric_extension_details'
require 'oci/stack_monitoring/models/disassociate_monitored_resources_details'
require 'oci/stack_monitoring/models/discovery_details'
require 'oci/stack_monitoring/models/discovery_job'
require 'oci/stack_monitoring/models/discovery_job_collection'
require 'oci/stack_monitoring/models/discovery_job_log_collection'
require 'oci/stack_monitoring/models/discovery_job_log_summary'
require 'oci/stack_monitoring/models/discovery_job_summary'
require 'oci/stack_monitoring/models/dynamic_group_details'
require 'oci/stack_monitoring/models/enable_metric_extension_details'
require 'oci/stack_monitoring/models/enabled_resource_details'
require 'oci/stack_monitoring/models/encrypted_credentials'
require 'oci/stack_monitoring/models/evaluate_baselineable_metric_details'
require 'oci/stack_monitoring/models/evaluate_baselineable_metric_result'
require 'oci/stack_monitoring/models/group_details'
require 'oci/stack_monitoring/models/handler_type'
require 'oci/stack_monitoring/models/http_protocol_types'
require 'oci/stack_monitoring/models/http_query_properties'
require 'oci/stack_monitoring/models/http_response_content_types'
require 'oci/stack_monitoring/models/http_script_file_details'
require 'oci/stack_monitoring/models/http_update_query_properties'
require 'oci/stack_monitoring/models/import_oci_telemetry_resources_task_details'
require 'oci/stack_monitoring/models/jmx_query_properties'
require 'oci/stack_monitoring/models/jmx_update_query_properties'
require 'oci/stack_monitoring/models/license_auto_assign_config_details'
require 'oci/stack_monitoring/models/license_auto_assign_config_summary'
require 'oci/stack_monitoring/models/license_enterprise_extensibility_config_details'
require 'oci/stack_monitoring/models/license_enterprise_extensibility_config_summary'
require 'oci/stack_monitoring/models/license_type'
require 'oci/stack_monitoring/models/lifecycle_state'
require 'oci/stack_monitoring/models/maintenance_window'
require 'oci/stack_monitoring/models/maintenance_window_collection'
require 'oci/stack_monitoring/models/maintenance_window_lifecycle_details'
require 'oci/stack_monitoring/models/maintenance_window_lifecycle_state'
require 'oci/stack_monitoring/models/maintenance_window_operation_status'
require 'oci/stack_monitoring/models/maintenance_window_operation_type'
require 'oci/stack_monitoring/models/maintenance_window_schedule'
require 'oci/stack_monitoring/models/maintenance_window_sort_by'
require 'oci/stack_monitoring/models/maintenance_window_summary'
require 'oci/stack_monitoring/models/manage_license_details'
require 'oci/stack_monitoring/models/member_reference'
require 'oci/stack_monitoring/models/member_reference_type'
require 'oci/stack_monitoring/models/message_format'
require 'oci/stack_monitoring/models/metric'
require 'oci/stack_monitoring/models/metric_data'
require 'oci/stack_monitoring/models/metric_extension'
require 'oci/stack_monitoring/models/metric_extension_collection'
require 'oci/stack_monitoring/models/metric_extension_collection_methods'
require 'oci/stack_monitoring/models/metric_extension_life_cycle_details'
require 'oci/stack_monitoring/models/metric_extension_life_cycle_states'
require 'oci/stack_monitoring/models/metric_extension_metric_aggregation_collection'
require 'oci/stack_monitoring/models/metric_extension_query_properties'
require 'oci/stack_monitoring/models/metric_extension_resource_aggregation'
require 'oci/stack_monitoring/models/metric_extension_resource_aggregation_collection'
require 'oci/stack_monitoring/models/metric_extension_sort_by'
require 'oci/stack_monitoring/models/metric_extension_summary'
require 'oci/stack_monitoring/models/metric_extension_update_query_properties'
require 'oci/stack_monitoring/models/metric_extensions_metric_aggregation'
require 'oci/stack_monitoring/models/metric_name_configuration_details'
require 'oci/stack_monitoring/models/monitored_resource'
require 'oci/stack_monitoring/models/monitored_resource_alias_credential'
require 'oci/stack_monitoring/models/monitored_resource_alias_source_credential'
require 'oci/stack_monitoring/models/monitored_resource_association'
require 'oci/stack_monitoring/models/monitored_resource_association_summary'
require 'oci/stack_monitoring/models/monitored_resource_associations_collection'
require 'oci/stack_monitoring/models/monitored_resource_collection'
require 'oci/stack_monitoring/models/monitored_resource_credential'
require 'oci/stack_monitoring/models/monitored_resource_details'
require 'oci/stack_monitoring/models/monitored_resource_member_summary'
require 'oci/stack_monitoring/models/monitored_resource_members_collection'
require 'oci/stack_monitoring/models/monitored_resource_property'
require 'oci/stack_monitoring/models/monitored_resource_sort_by'
require 'oci/stack_monitoring/models/monitored_resource_summary'
require 'oci/stack_monitoring/models/monitored_resource_task'
require 'oci/stack_monitoring/models/monitored_resource_task_details'
require 'oci/stack_monitoring/models/monitored_resource_task_lifecycle_state'
require 'oci/stack_monitoring/models/monitored_resource_task_summary'
require 'oci/stack_monitoring/models/monitored_resource_tasks_collection'
require 'oci/stack_monitoring/models/monitored_resource_type'
require 'oci/stack_monitoring/models/monitored_resource_type_summary'
require 'oci/stack_monitoring/models/monitored_resource_types_collection'
require 'oci/stack_monitoring/models/monitored_resources_count_aggregation'
require 'oci/stack_monitoring/models/monitored_resources_count_aggregation_collection'
require 'oci/stack_monitoring/models/monitoring_template'
require 'oci/stack_monitoring/models/monitoring_template_collection'
require 'oci/stack_monitoring/models/monitoring_template_life_cycle_details'
require 'oci/stack_monitoring/models/monitoring_template_life_cycle_states'
require 'oci/stack_monitoring/models/monitoring_template_summary'
require 'oci/stack_monitoring/models/onboard_config_details'
require 'oci/stack_monitoring/models/onboard_config_summary'
require 'oci/stack_monitoring/models/one_time_maintenance_window_schedule'
require 'oci/stack_monitoring/models/operation_status'
require 'oci/stack_monitoring/models/operation_type'
require 'oci/stack_monitoring/models/os_command_query_properties'
require 'oci/stack_monitoring/models/os_command_update_query_properties'
require 'oci/stack_monitoring/models/plain_text_credentials'
require 'oci/stack_monitoring/models/pre_existing_credentials'
require 'oci/stack_monitoring/models/process_set'
require 'oci/stack_monitoring/models/process_set_collection'
require 'oci/stack_monitoring/models/process_set_specification'
require 'oci/stack_monitoring/models/process_set_specification_details'
require 'oci/stack_monitoring/models/process_set_summary'
require 'oci/stack_monitoring/models/property_details'
require 'oci/stack_monitoring/models/recurrent_maintenance_window_schedule'
require 'oci/stack_monitoring/models/request_summarized_metric_extensions_metrics_details'
require 'oci/stack_monitoring/models/request_summarized_metric_extensions_resources_details'
require 'oci/stack_monitoring/models/resource_category'
require 'oci/stack_monitoring/models/resource_lifecycle_state'
require 'oci/stack_monitoring/models/resource_type_config_details'
require 'oci/stack_monitoring/models/resource_type_lifecycle_state'
require 'oci/stack_monitoring/models/resource_type_metadata_details'
require 'oci/stack_monitoring/models/script_file_details'
require 'oci/stack_monitoring/models/search_associated_resources_details'
require 'oci/stack_monitoring/models/search_monitored_resource_associations_details'
require 'oci/stack_monitoring/models/search_monitored_resource_members_details'
require 'oci/stack_monitoring/models/search_monitored_resources_details'
require 'oci/stack_monitoring/models/sort_order'
require 'oci/stack_monitoring/models/source_type'
require 'oci/stack_monitoring/models/sql_details'
require 'oci/stack_monitoring/models/sql_in_param_details'
require 'oci/stack_monitoring/models/sql_out_param_details'
require 'oci/stack_monitoring/models/sql_out_param_types'
require 'oci/stack_monitoring/models/sql_query_properties'
require 'oci/stack_monitoring/models/sql_query_types'
require 'oci/stack_monitoring/models/sql_update_query_properties'
require 'oci/stack_monitoring/models/system_format_resource_type_metadata_details'
require 'oci/stack_monitoring/models/telegraf_resource_name_configuration_details'
require 'oci/stack_monitoring/models/test_metric_extension_data'
require 'oci/stack_monitoring/models/test_metric_extension_details'
require 'oci/stack_monitoring/models/unique_property_set'
require 'oci/stack_monitoring/models/update_agent_receiver_task_details'
require 'oci/stack_monitoring/models/update_alarm_condition_details'
require 'oci/stack_monitoring/models/update_and_propagate_tags_details'
require 'oci/stack_monitoring/models/update_auto_promote_config_details'
require 'oci/stack_monitoring/models/update_baselineable_metric_details'
require 'oci/stack_monitoring/models/update_compute_auto_activate_plugin_config_details'
require 'oci/stack_monitoring/models/update_config_details'
require 'oci/stack_monitoring/models/update_http_script_file_details'
require 'oci/stack_monitoring/models/update_license_auto_assign_config_details'
require 'oci/stack_monitoring/models/update_license_enterprise_extensibility_config_details'
require 'oci/stack_monitoring/models/update_maintenance_window_details'
require 'oci/stack_monitoring/models/update_metric_extension_details'
require 'oci/stack_monitoring/models/update_monitored_resource_details'
require 'oci/stack_monitoring/models/update_monitored_resource_task_details'
require 'oci/stack_monitoring/models/update_monitored_resource_type_details'
require 'oci/stack_monitoring/models/update_monitoring_template_details'
require 'oci/stack_monitoring/models/update_onboard_config_details'
require 'oci/stack_monitoring/models/update_process_set_details'
require 'oci/stack_monitoring/models/update_resource_type_config_task_details'
require 'oci/stack_monitoring/models/work_request'
require 'oci/stack_monitoring/models/work_request_error'
require 'oci/stack_monitoring/models/work_request_error_collection'
require 'oci/stack_monitoring/models/work_request_log_entry'
require 'oci/stack_monitoring/models/work_request_log_entry_collection'
require 'oci/stack_monitoring/models/work_request_resource'
require 'oci/stack_monitoring/models/work_request_summary'
require 'oci/stack_monitoring/models/work_request_summary_collection'

# Require generated clients
require 'oci/stack_monitoring/stack_monitoring_client'
require 'oci/stack_monitoring/stack_monitoring_client_composite_operations'

# Require service utilities
require 'oci/stack_monitoring/util'
